<?php

class ApproveController extends AdmController {

    protected function beforeAction($action) {
        if (parent::beforeAction($action)) {
            Yii::app()->session['sidebar_active'] = 'approve';
            return true;
        }
        return false;
    }

    public function actionIndex() {
        $grids = $this->getGridData('00');
        $this->render('index', array('grids' => $grids, 'approve_status' => '00'));
    }

    public function actionAjaxList() {
        $offset = (isset($_GET['page'])) ? $_GET['page'] : 0;

        $approve_status = $_POST['approve_status'];
        $txtsearch = $_POST['txtsearch'];
        $start_date = MyDate::dateToMysql($_POST['start_date']);
        $end_date = MyDate::dateToMysql($_POST['end_date']);

        $grids = $this->getGridData($approve_status, $txtsearch, $start_date, $end_date, $offset);
        $this->renderPartial('_gridview', array('grids' => $grids));
    }

    public function getGridData($approve_status = '', $txtsearch = '', $start_date = '', $end_date = '', $offset = 0) {
        $user_id = Yii::app()->user->id;

        $sql = "SELECT tb_reserv.id, tb_reserv.docno, tb_reserv.docdate, tb_reserv.doctime, ";
        $sql .= " tb_room.`name` as room_name, tb_reserv.start_date, tb_reserv.end_date, tb_reserv.title, ";
        $sql .= " tb_depart.`name` as depart_name, tb_reserv.status, tb_reserv.read_date, tb_reserv.approve_date,tb_reserv.room_id";
        $sql .= " FROM tb_reserv LEFT JOIN tb_userdepart ON tb_reserv.depart_id = tb_userdepart.depart_id";
        $sql .= " LEFT JOIN tb_room ON tb_room.id = tb_reserv.room_id";
        $sql .= " LEFT JOIN tb_depart ON tb_depart.id = tb_reserv.depart_id";
        $sql .= " WHERE tb_userdepart.user_id = '$user_id'";
        $sql .= " AND tb_room.name LIKE '%$txtsearch%'";

        if ($approve_status != '') {
            if ($approve_status == '00') {
                $sql .= " AND (tb_reserv.status='0' or tb_reserv.status='1')";
            } else {
                $sql .= " AND tb_reserv.status='$approve_status'";
            }
        }

        if ($start_date != '' && $end_date != '') {
            $sql .= " AND (date(tb_reserv.start_date) >= '$start_date'";
            $sql .= " AND date(tb_reserv.end_date) <= '$end_date')";
        } else if ($start_date != '' && $end_date == '') {
            //กรอกแต่วันที่เริ่ม
            $sql .= " AND (date(tb_reserv.start_date) >= '$start_date')";
        } else if ($start_date == '' && $end_date != '') {
            //กรอกแต่วันที่สิ้นสุด
            $sql .= " AND (date(tb_reserv.start_end) <= '$end_date')";
        }

        $count = Yii::app()->db->createCommand($sql)->execute();
        $pages = new CPagination($count);
        $pages->route = 'ajaxList';

        $pageLimit = Yii::app()->params['pageSize'];

        if ($offset > 0) {
            $recordStart = ($offset * $pageLimit) - $pageLimit;
        } else {
            $recordStart = 0;
        }

        $pages->pageSize = $pageLimit;
        $sql .= " ORDER BY date(tb_reserv.start_date) asc, tb_reserv.docno asc";
        $sql .= " limit $recordStart,$pageLimit";

        $models = Yii::app()->db->createCommand($sql)->queryAll();


        return array('models' => $models, 'pages' => $pages, 'count' => $count);
    }

    public function actionUpdate() {
        if (isset($_GET['id'])) {
            $model = Reserv::model()->findByPk((int) $_GET['id']);
            if ($model->status == '0') {
                $model->status = '1';
                $model->read_date = date('Y-m-d H:i:s');
                $model->approve_date = date('Y-m-d H:i:s');
                $model->save();
            }
        }

        if (isset($_POST['Reserv'])) {
            //submit มาจาก form 
            $model = Reserv::model()->findByPk($_POST['id']);
            $oldStatus = $model->status;    //เก็บสถานะเก่า เพื่อประโยชน์ในการ +- จำนวนอุปกรณ์

            $model->attributes = $_POST['Reserv'];
            $model->approve_date = date('Y-m-d H:i:s');
            $model->user_approve_id = Yii::app()->user->id;

            if ($model->status == '2') {
                $model->cancel_doc = '0';
            }

            if ($model->save()) {

                if ($oldStatus !== '3' && $oldStatus !== '4') {
                    if ($model->status === '3' || $model->status === '4') {
                        $equipOrders = EquipOrder::model()->findAll(array("condition" => "reserv_id='$model->id'"));
                        foreach ($equipOrders as $ed) {
                            Equip::model()->increment($ed->equip_id, $ed->amount);
                            EquipOrder::model()->updateStatus($ed->id);
                        }
                    }
                }

                if ($oldStatus === '3' || $oldStatus === '4') {
                    if ($model->status === '0' || $model->status == '1' || $model->status === '2') {
                        $equipOrders = EquipOrder::model()->findAll(array("condition" => "reserv_id='$model->id'"));
                        foreach ($equipOrders as $ed) {
                            Equip::model()->decrement($ed->equip_id, $ed->amount);
                            EquipOrder::model()->updateStatus($ed->id, 0);
                        }
                    }
                }


                Yii::app()->user->setFlash('success', 'บันทึกผลการอนุมัติเรียบร้อย');
                $this->redirect(array('/approve'));
            } else {
                Yii::app()->user->setFlash('success', 'ไม่สามารถบันทึกข้อมูลได้เนื่องจาก ' . $model->getErrors());
                $this->redirect(array('update', 'id' => $model->id));
            }
        }
        $this->render('form', array('model' => $model));
    }

}
