<?php

class ApprovecancelController extends AdmController {

    protected function beforeAction($action) {
        if (parent::beforeAction($action)) {
            Yii::app()->session['sidebar_active'] = 'approvecancel';
            return true;
        }
        return false;
    }

    public function actionIndex() {
        $grids = $this->getGridData();
        $this->render('index', array('grids' => $grids));
    }

    public function actionAjaxList() {
        $offset = (isset($_GET['page'])) ? $_GET['page'] : 0;

        $grids = $this->getGridData($offset);
        $this->renderPartial('_gridview', array('grids' => $grids));
    }

    public function getGridData($offset = 0) {
        $user_id = Yii::app()->user->id;

        $sql = "SELECT tb_reserv.id, tb_reserv.docno, tb_reserv.docdate, tb_reserv.doctime, ";
        $sql .= " tb_room.`name` as room_name, tb_reserv.start_date, tb_reserv.end_date, tb_reserv.title, ";
        $sql .= " tb_depart.`name` as depart_name, tb_reserv.status, tb_reserv.read_date, ";
        $sql .= " tb_reserv.date_edit, tb_reserv.approve_date,tb_reserv.room_id";
        $sql .= " FROM tb_reserv LEFT JOIN tb_userdepart ON tb_reserv.depart_id = tb_userdepart.depart_id";
        $sql .= " LEFT JOIN tb_room ON tb_room.id = tb_reserv.room_id";
        $sql .= " LEFT JOIN tb_depart ON tb_depart.id = tb_reserv.depart_id";
        $sql .= " WHERE (tb_userdepart.user_id = '$user_id') AND (tb_reserv.status='2' AND tb_reserv.cancel_doc='1')";

        $count = Yii::app()->db->createCommand($sql)->execute();

        $pages = new CPagination($count);
        $pages->route = 'ajaxList';

        $pageLimit = Yii::app()->params['pageSize'];

        if ($offset > 0) {
            $recordStart = ($offset * $pageLimit) - $pageLimit;
        } else {
            $recordStart = 0;
        }

        $pages->pageSize = $pageLimit;
        $sql .= " ORDER BY tb_reserv.docdate asc, tb_reserv.doctime asc, tb_reserv.docno asc";
        $sql .= " limit $recordStart,$pageLimit";
        $models = Yii::app()->db->createCommand($sql)->queryAll();


        return array('models' => $models, 'pages' => $pages, 'count' => $count);
    }

    public function actionUpdate() {
        if (isset($_GET['id'])) {
            $model = Reserv::model()->findByPk((int) $_GET['id']);
        }

        if (isset($_POST['Reserv'])) {
            //submit มาจาก form แต่ต้องทำการอัพโหลดไฟล์ก่อน
            $id = (int)$_POST['id'];
            $model = Reserv::model()->findByPk($id);
            $model->attributes = $_POST['Reserv'];
            $model->approve_date = date('Y-m-d H:i:s');
            $model->user_approve_id = Yii::app()->user->id;
            $model->status = '4';

            if ($model->save()) {
                //เปลี่ยนวันที่เป้นวันที่ปัจจุบัน เพื่อประโยชน์ในการอัพเดท stock  อุปกรณ์
                $now = date('Y-m-d H:i:s');
                Yii::app()->db->createCommand("update tb_equip_order set end_date='$now' where reserv_id='$id'")->execute(); //เปลี่ยนวันที่เป้นวันที่ปัจจุบัน เพื่อประโยชน์ในการอัพเดท stock  อุปกรณ์

                Yii::app()->user->setFlash('success', 'อนุมัติการยกเลิกจองเรียบร้อย');
                $this->redirect(array('/approvecancel'));
            } else {
                Yii::app()->user->setFlash('success', 'ไม่สามารถบันทึกข้อมูลได้เนื่องจาก ' . $model->getErrors());
                $this->redirect(array('update', 'id' => $model->id));
            }
        }
        $this->render('form', array('model' => $model));
    }

}
