<?php

class CompanyController extends AdmController {

    protected function beforeAction($action) {
        if (parent::beforeAction($action)) {
            Yii::app()->session['sidebar_active'] = 'company';
            return true;
        }
        return false;
    }
    
    public function actionIndex() {
        if(Company::model()->count()==0){
            $model = new Company;
        }else{
            $model = Company::model()->find();
        }

        if (isset($_POST['Company'])) {

            if ($_POST['id'] == '') {
                $model = new Company;
            } else {
                //submit มาจาก form
                $model = Company::model()->findByPk($_POST['id']);
            }

            $model->attributes = $_POST['Company'];
            Yii::app()->session['webheader'] = $model->webheader;

            if ($model->save()) {
                /* === อัพโหลดไฟล์รูปประจำตัว=== */
                if (isset($_FILES["logo"])) {
                    $dir = Yii::getPathOfAlias("webroot.fileupload.user");
                    $uploadedFile = CUploadedFile::getInstanceByName("logo");
                    if ($uploadedFile !== null) {
                        $new_name = "logo." . $uploadedFile->getExtensionName();  //เปลี่ยนชื่อไฟล์

                        $uploadedFile->saveAs($dir . '/' . $new_name);
                        $row = Company::model()->findByPk($model->id);

                        $row->logo = $new_name;
                        $row->save();     //เก็บข้อมูลลง Database

                        Yii::import('application.extensions.image.Image');
                        $image = new Image($dir . '/' . $new_name);
                        if ($image->width > 150 || $image->height > 150) {
                            $image->resize(150, 150, Image::AUTO);
                            $image->save();
                        }
                    }
                }
                
                Yii::app()->user->setFlash('success', 'บันทึกข้อมูลเรียบร้อย');
                $this->redirect(array('index', 'id' => $model->id));
            } else {
                Yii::app()->user->setFlash('success', 'ไม่สามารถบันทึกข้อมูลได้เนื่องจาก ' . $model->getErrors());
                $this->redirect(array('index', 'id' => $model->id));
            }
        }
        $this->render('form', array('model' => $model));
    }
}
