<?php

class EquipOrderController extends AdmController {

    protected function beforeAction($action) {
        if (parent::beforeAction($action)) {
            Reserv::model()->clearDraft();
            Yii::app()->session['sidebar_active'] = 'reserv';
            return true;
        }
        return false;
    }

    public function actionIndex() {
        $this->redirect('calendar');
    }

    public function actionAjaxList() {
        $id = (int) $_POST['reserv_id'];
        $grids = $this->getGridData($id);
        $this->renderPartial('//reserv/_gridview_equip_order', array('grids' => $grids));
    }

    public function getGridData($reservID = '') {
        $criteria = new CDbCriteria;
        $criteria->with = array(
            'equip' => array(
                'together' => true,
            ),
        );
        $criteria->condition = "t.reserv_id  = $reservID";
        $models = EquipOrder::model()->findAll($criteria);

        return array('models' => $models);
    }

    public function actionAjaxSave() {
        $reservID = (int) $_POST['reservID'];
        $equipID = (int) $_POST['equipID'];
        $amount = (int) $_POST['amount'];
        $equip = Equip::model()->findByPk($equipID);

        $msg = '0';
        $msgText = '';
        if (isset($equip)) {
            $newBalance = (int) ($equip->balance - $amount);
            if ($newBalance < 0 && $equip->amount > 0) {
                $msg = '1';
                $msgText = 'จำนวนคงเหลือน้อยกว่าจำนวนที่คุณต้องการใช้อุปกรณ์';
            } else {
                $reserv = Reserv::model()->findByPk($reservID);

                $model = new EquipOrder;
                $model->reserv_id = $reservID;
                $model->equip_id = $equipID;
                $model->amount = $amount;
                $model->description = CHtml::encode($_POST['description']);
                $model->end_date = $reserv->end_date;
                if ($model->save()) {
                    Equip::model()->decrement($equipID, $amount);
                } else {
                    $msg = '1';
                    $msgText = $model->getErrors();
                }
            }
        } else {
            $msg = '1';
            $msgText = 'อุปกรณ์ดังกล่าวไม่มีในฐานข้อมูลแล้ว อาจถูกลบไปก่อนหน้านี้ไม่กี่วินาที';
        }

        $data = array(
            'msg' => $msg,
            'msgText' => $msgText
        );

        echo CJSON::encode($data);
    }

    public function actionAjaxDelete() {
        $msg = '0';
        $row = EquipOrder::model()->findByPk((int) $_POST['id']);
        if ($row->delete()) {
            Equip::model()->increment($row->equip_id, $row->amount);
        }
        $data['msg'] = $msg;
        echo CJSON::encode($data);
    }

}
