<?php
//ดู functionsheet  แบบไม่ต้อง login
class FsheetController extends Controller {

    protected function beforeAction($action) {
        if (parent::beforeAction($action)) {
            Yii::app()->session['sidebar_active'] = 'fsheet';
            return true;
        }
        return false;;
    }

    public function actionIndex() {
        $txtsearch = Yii::app()->session['functionsheet_txtsearch'];
        $fdate = Yii::app()->session['functionsheet_fdate'];
        $edate = Yii::app()->session['functionsheet_edate'];

        $grids = $this->getGridData($txtsearch, $fdate, $edate);
        $this->render('index', array(
            'grids' => $grids,
            'txtsearch' => $txtsearch,
            'fdate' => MyDate::dateToText($fdate),
            'edate' => MyDate::dateToText($edate)
        ));
    }

    public function actionAjaxList() {
        $fdate = MyDate::dateToMysql($_POST['fdate']);
        $edate = MyDate::dateToMysql($_POST['edate']);

        Yii::app()->session['functionsheet_txtsearch'] = $_POST['txtsearch'];
        Yii::app()->session['functionsheet_fdate'] = $fdate;
        Yii::app()->session['functionsheet_edate'] = $edate;

        $grids = $this->getGridData($_POST['txtsearch'], $fdate, $edate);
        $this->renderPartial('_gridview', array('grids' => $grids));
    }

    public function getGridData($txtsearch = '', $fdate = '', $edate = '') {
        if ($fdate == '') {
            $fdate = '1900-01-01';
        }
        if ($edate == '') {
            $edate = '2500-01-01';
        }

        $criteria = new CDbCriteria;
        $criteria->condition = "(docno LIKE :txtsearch or organizer LIKE :txtsearch or company LIKE :txtsearch or tel LIKE :txtsearch)";
        $criteria->condition.= " AND (docdate between '$fdate' AND '$edate')";
        $criteria->params = array(':txtsearch' => "%$txtsearch%");
        $criteria->order = 'docdate desc';

        $count = Functionsheet::model()->count($criteria);

        $pages = new CPagination($count);
        $pages->route = 'ajaxList';
        $pages->pageSize = Yii::app()->params['pageSize'];
        $pages->applyLimit($criteria);
        $models = Functionsheet::model()->findAll($criteria);

        return array('models' => $models, 'pages' => $pages, 'count' => $count);
    }

    public function actionDetail() {
        $id = (isset($_GET['id'])) ? (int) $_GET['id'] : '';
        $model = Functionsheet::model()->findByPk($id);

        $grids_food = $this->getGridDataFood($id);
        $this->render('detail', array('model' => $model, 'grids_food' => $grids_food));
    }
    
    public function getGridDataFood($functionsheet_id) {
        $criteria = new CDbCriteria;
        $criteria->condition = "functionsheet_id='$functionsheet_id'";
        $criteria->order = 'abs(no) asc';

        $models = Functionfood::model()->findAll($criteria);
        return array('models' => $models);
    }
    
        //พิมพ์ใบฟังก์ชัน
    public function actionPreview() {
        $report_file = (int) $_POST['report_file'];
        $id = (int) $_POST['id'];

        $model = Functionsheet::model()->findByPk($id);
        $company = Company::model()->find();

        $imagePath = $company->getImagePath($company->id);
        
        $tbl = '';
        if($imagePath!=''){
            $tbl.= "<p align='center'><img src='".$imagePath."' width='60'/></p>";
        }
        $caption = $company->name;
        $tbl.= "<div class='caption'>$caption</div>";
        $tbl.= <<<EOD
          <table class='noborder1' style="overflow:wrap;">
          <tbody>
EOD;

        $tbl.="<tr>";
        $tbl.="<td width='120'><b>FUNCTION NO</b></td>";
        $tbl.="<td width='300' x:str>$model->docno</td>";
        $tbl.="<td width='120'><b>DATE OF ISSUE</b></td>";
        $tbl.="<td>" . MyDate::dateToText($model->docdate) . "</td>";
        $tbl.="</tr>";

        $tbl.="<tr valign='top'>";
        $tbl.="<td><b>ORGANIZER</b></td>";
        $tbl.="<td>$model->organizer</td>";
        $tbl.="<td><b>BOOKED BY</b></td>";
        $tbl.="<td>$model->booked_by</td>";
        $tbl.="</tr>";

        $tbl.="<tr valign='top'>";
        $tbl.="<td><b>COMPANY</b></td>";
        $tbl.="<td>$model->company</td>";
        $tbl.="<td><b>TEL.</b></td>";
        $tbl.="<td>$model->tel</td>";
        $tbl.="</tr>";

        $tbl.="<tr valign='top'>";
        $tbl.="<td><b>DAY</b></td>";
        $tbl.="<td colspan='3'>$model->daybook&nbsp;&nbsp;&nbsp;&nbsp;<b>DATE&nbsp;&nbsp;</b>$model->datebook&nbsp;&nbsp;&nbsp;&nbsp;<b>TIME&nbsp;&nbsp;</b>$model->timebook</td>";
        $tbl.="</tr>";

        $tbl.="<tr valign='top'>";
        $tbl.="<td><b>ROOM</b></td>";
        $tbl.="<td colspan='3'>" . $model->room['name'] . "</td>";
        $tbl.="</tr>";

        $tbl.="<tr valign='top'>";
        $tbl.="<td><b>GURANTEED</b></td>";
        $tbl.="<td colspan='3'>" . $model->guaranteed . "</td>";
        $tbl.="</tr>";

        $tbl.="<tr valign='top'>";
        $tbl.="<td><b>ACOOUNT TO</b></td>";
        $tbl.="<td colspan='3'>" . $model->accountto . "</td>";
        $tbl.="</tr>";

        $tbl.="<tr valign='top'>";
        $tbl.="<td><b>ADDRESS</b></td>";
        $tbl.="<td colspan='3'>" . $model->address . "</td>";
        $tbl.="</tr>";

        $tbl.="<tr valign='top'>";
        $tbl.="<td><b>PRICE</b></td>";
        $tbl.="<td colspan='3'>" . $model->pricetext . "</td>";
        $tbl.="</tr>";

        $tbl.="<tr valign='top'>";
        $tbl.="<td><b>COMMENT</b></td>";
        $tbl.="<td colspan='3'>" . $model->comment . "</td>";
        $tbl.="</tr>";

        $tbl.="<tr valign='top'>";
        $tbl.="<td colspan='2'><b>TIME TABLE</b><br/>$model->timetable</td>";
        $tbl.="<td colspan='2'><b>ACCOUNTS</b><br/>$model->accounts<br/><span style='font-size:11pt'><b><i>รวมค่าใช้จ่าย</i> " . number_format($model->accounts_price) . " <i>บาท</i></b></span></td>";
        $tbl.="</tr>";

        $tbl.="<tr valign='top'>";
        $tbl.="<td colspan='2'><b>FOOD ARRANGEMENTS</b><br/>$model->food_ar</td>";
        $tbl.="<td colspan='2'><b>SPECIAL FOOD ARRANGEMENTS</b><br/>$model->food_sp</td>";
        $tbl.="</tr>";

        $tbl.="<tr valign='top'>";
        $tbl.="<td colspan='2'><b>BEVERAGE ARRANGEMENTS</b><br/>$model->beverage</td>";
        $tbl.="<td colspan='2'><b>ROOM SETUP</b><br/>$model->roomsetup</td>";
        $tbl.="</tr>";

        $tbl.="<tr valign='top'>";
        $tbl.="<td colspan='2'><b>FLORIST</b><br/>$model->florist</td>";
        $tbl.="<td colspan='2'><b>ARTIST</b><br/>$model->artist</td>";
        $tbl.="</tr>";

        $tbl.="<tr valign='top'>";
        $tbl.="<td colspan='2'><b>AV/LIGHTING</b><br/>$model->av</td>";
        $tbl.="<td colspan='2'><b>P.R.</b><br/>$model->pr</td>";
        $tbl.="</tr>";

        $tbl.="</tbody></table><br/><br/>";
        $tbl.="<table class='noborder' style='font-size:11pt'>";
        $tbl.="<tr>";
        $tbl.="<td width='50%' align='center'>";
        $tbl.="<b>ผู้ตรวจสอบ: </b>$model->approve<br/><br/><br/>";
        $tbl.="<b>(......................................................................)</b><br/><br/>";
        $tbl.="</b>ตำแหน่ง: </b> $model->position";
        $tbl.="</td>";
        $tbl.="<td width='50%' align='center'>";
        $tbl.="<b>ผู้ออกใบฟังก์ชัน: </b>$model->bookbyname<br/><br/><br/>";
        $tbl.="<b>(......................................................................)</b><br/><br/>";
        $tbl.="</b>ตำแหน่ง: </b> $model->bookbyposition";
        $tbl.="</td>";
        $tbl.="</tr>";
        $tbl.="</table>";

        $tbl.="<div class='page-break'></div><pagebreak />";
        $tbl.= "<div class='caption'>รายการอาหารคณะ $model->organizer $model->company</div>";

        $criteria = new CDbCriteria;
        $criteria->condition = "functionsheet_id='$model->id'";
        $criteria->order = "abs(no) asc";
        $foods = Functionfood::model()->findAll($criteria);
        $i = 0;
        $tbl.= <<<EOD
          <table class='noborder' style="overflow:wrap;font-size:11pt">
EOD;

        foreach ($foods as $r) {
            if (!$i % 2) {
                $tbl.="<tr>";
            }
            $tbl.="<td width='50%'><b>$r->title</b><br/>$r->detail</td>";
            if ($i % 2) {
                $tbl.="</tr>";
            }
            $i++;
        }
        
        if($i>0){
            $tbl.="</tr>";
        }
        $tbl.="</table><br/><br/><p align='center'><b>** อาหารเปลี่ยนแปลงได้ตามความเหมาะสม **</b></p>";
        
        $rpt = new ReportForm;
        $content = $tbl;

        if ($report_file == '1') {
            $this->renderPartial("//layouts/report_html_a4", array('content' => $content, 'report_name' => 'รายงาน'));
        } else {
            $mpdf = $rpt->getMPDF();
            $mpdf->WriteHTML($rpt->getCssPdf(), 1);
            $mpdf->WriteHTML($content, 2);
            $mpdf->Output();
        }
    }
    
}
