<?php

class ReservController extends AdmController {

    protected function beforeAction($action) {
        if (parent::beforeAction($action)) {
            Reserv::model()->clearDraft();
            Equip::model()->updateBalance();
            Yii::app()->session['sidebar_active'] = 'reserv';
            return true;
        }
        return false;
    }

    public function actionIndex() {
        $reserv_txt = Yii::app()->session['reserv_txt'];          //id ห้องประชุม
        $reserv_status = Yii::app()->session['reserv_status'];    //สถานะ
        $reserv_start_date = Yii::app()->session['reserv_start_date'];      //จากวันใช้งาน
        $reserv_end_date = Yii::app()->session['reserv_end_date'];      //ถึงวันที่ใช้งาน

        $grids = $this->getGridData($reserv_txt, $reserv_status, $reserv_start_date, $reserv_end_date);
        $this->render('index', array('grids' => $grids,
            'reserv_status' => $reserv_status,
            'reserv_txt' => $reserv_txt,
            'reserv_start_date' => $reserv_start_date,
            'reserv_end_date' => $reserv_end_date));
    }

    public function actionAjaxList() {
        $offset = (isset($_GET['page'])) ? $_GET['page'] : 0;

        Yii::app()->session['reserv_txt'] = $_POST['txtsearch'];
        Yii::app()->session['reserv_status'] = $_POST['reserv_status'];
        Yii::app()->session['reserv_start_date'] = $_POST['start_date'];
        Yii::app()->session['reserv_end_date'] = $_POST['end_date'];

        $grids = $this->getGridData($_POST['txtsearch'], $_POST['reserv_status'], $_POST['start_date'], $_POST['end_date'], $offset);
        $this->renderPartial('_gridview', array('grids' => $grids));
    }

    public function getGridData($reserv_txt = '', $reserv_status = '', $reserv_start_date = '', $reserv_end_date = '', $offset = 0) {
        $sql = "SELECT tb_reserv.id, tb_reserv.docno, tb_reserv.docdate, tb_reserv.doctime,";
        $sql .= " tb_reserv.start_date, tb_reserv.end_date, tb_reserv.status,";
        $sql .= " tb_room.name as room_name, tb_reserv.person_name, ";
        $sql .= " tb_reserv.title, tb_reserv.status, tb_reserv.cancel_doc FROM tb_reserv ";
        $sql .= " LEFT JOIN tb_room ON tb_reserv.room_id = tb_room.id";
        $sql .= " Where user_save_id='" . Yii::app()->user->id . "'";
        $sql .= " AND (tb_room.name LIKE '%$reserv_txt%' or tb_reserv.title LIKE '%$reserv_txt%'  or tb_reserv.docno LIKE '%$reserv_txt%')";
        if ($reserv_status != '') {
            if ($reserv_status == '00') {
                $sql .= " AND (tb_reserv.status='0' or tb_reserv.status='1')";
            } else {
                $sql .= " AND tb_reserv.status='$reserv_status'";
            }
        }

        $reserv_start_date = MyDate::dateToMysql($reserv_start_date);
        $reserv_end_date = MyDate::dateToMysql($reserv_end_date);
        if ($reserv_start_date == '')
            $reserv_start_date = '0000-00-00';
        if ($reserv_end_date == '')
            $reserv_end_date = '3000-01-01';

        $sql .= " AND (";
        $sql .= " (date(tb_reserv.start_date) between '$reserv_start_date' AND '$reserv_end_date')";
        $sql .= " OR (date(tb_reserv.end_date) between '$reserv_start_date' AND '$reserv_end_date')";
        $sql .= " OR ('$reserv_start_date' between date(tb_reserv.start_date) AND date(tb_reserv.end_date))";
        $sql .= " OR ('$reserv_end_date' between date(tb_reserv.start_date) AND date(tb_reserv.end_date))";
        $sql .= ")";

        $count = Yii::app()->db->createCommand($sql)->execute();

        $pages = new CPagination($count);
        $pages->route = 'ajaxList';

        $pageLimit = Yii::app()->params['pageSize'];

        if ($offset > 0) {
            $recordStart = ($offset * $pageLimit) - $pageLimit;
        } else {
            $recordStart = 0;
        }

        $pages->pageSize = $pageLimit;
        $sql .= " Order By tb_reserv.start_date asc, tb_reserv.docno asc";
        $sql .= " limit $recordStart,$pageLimit";
        $models = Yii::app()->db->createCommand($sql)->queryAll();
        return array('models' => $models, 'pages' => $pages, 'count' => $count);
    }

    public function actionAjaxBusyDetail() {
        $room_id = $_POST['room_id'];
        $filter = array(
            'start_date' => MyDate::dateToMysql($_POST['start_date']) . " " . $_POST['start_time'],
            'end_date' => MyDate::dateToMysql($_POST['end_date']) . " " . $_POST['end_time'],
        );

        $timeBefor = 0; //ต้องจองก่อนถึงเวลารถว่าง กี่นาทีแต่ในโปรแกรมไม่ได้ระบุไว้เลยกำหนดเป็น 0
        if ($timeBefor == 0) {
            $stime = '00:00:01';
            $etime = '-00:00:01';
        } else {
            $timeBefor--;
            $t = sprintf('%02d', $timeBefor);
            $stime = "-00:$t:00";
            $etime = "00:$t:00";
        }

        $sql = "select tb_reserv.*,tb_room.name as room_name, tb_depart.name as depart_name from tb_reserv";
        $sql .= " LEFT JOIN tb_room on tb_reserv.room_id = tb_room.id";
        $sql .= " LEFT JOIN tb_depart on tb_reserv.depart_id = tb_depart.id";
        $sql .= " where (tb_reserv.status = '0' or tb_reserv.status='1' or tb_reserv.status='2' or tb_reserv.status='9')";
        $sql .= " AND (tb_reserv.room_id='$room_id')";
        $sql .= " AND (";
        $sql .= " (ADDTIME(start_date, '$stime' ) between '" . $filter['start_date'] . "' AND '" . $filter['end_date'] . "')";
        $sql .= " OR (ADDTIME(end_date, '$etime') between '" . $filter['start_date'] . "' AND '" . $filter['end_date'] . "')";
        $sql .= " OR ('" . $filter['start_date'] . "' between ADDTIME(start_date, '$stime' ) AND ADDTIME(end_date, '$etime'))";
        $sql .= " OR ('" . $filter['end_date'] . "' between ADDTIME(start_date, '$stime' ) AND ADDTIME(end_date, '$etime'))";
        $sql .= ")";
        $models = Yii::app()->db->createCommand($sql)->queryAll();

        $this->renderPartial('_detail_busy', array('models' => $models));
    }

    public function actionCreate() {
        $places = Yii::app()->db->createCommand("SELECT tb_room.place FROM tb_room GROUP BY tb_room.place ORDER BY tb_room.place ASC")->queryAll();
        $this->render('search_room', array('places' => $places));
    }

//แสดงรายการห้องที่จะจอง
    public function actionAjaxListRoom() {
        $offset = (isset($_GET['page'])) ? $_GET['page'] : 0;

        $filter = array(
            'txtstatus' => $_POST['txtstatus'],
            'start_date' => MyDate::dateToMysql($_POST['start_date']) . " " . $_POST['start_time'],
            'end_date' => MyDate::dateToMysql($_POST['end_date']) . " " . $_POST['end_time'],
            'place' => $_POST['place'],
        );

        if ($filter['end_date'] <= $filter['start_date']) {
            $message = array(
                'start_date' => $_POST['start_date'] . " " . $_POST['start_time'],
                'end_date' => $_POST['end_date'] . " " . $_POST['end_time'],
            );
            $this->renderPartial('_error', array('message' => $message));
        } else {
            $grids = $this->getGridDataRoom($filter, $offset);
            $this->renderPartial('_room_grid_view', array('grids' => $grids));
        }
    }

    public function getGridDataRoom($filter, $offset = 0) {
        $sql = "
            DROP TEMPORARY TABLE IF EXISTS tmp_roombusy;
            CREATE TEMPORARY TABLE IF NOT EXISTS `tmp_roombusy` (
                `room_id` INT NULL ,
                `room_status` INT NULL ,
                `room_name` VARCHAR( 100 ) NULL ,
                `sit_amount` INT NULL ,
                `place` VARCHAR( 200 ) NULL ,
                `status` INT NULL ,
                `reserv_status` INT NULL ,
                `id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY
            ) ENGINE = MYISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;
            ";
        Yii::app()->db->createCommand($sql)->execute();
        $models = Room::model()->findAll();

        $timeBefor = 0; //ต้องจองก่อนถึงเวลาห้องว่าง กี่นาที
        if ($timeBefor == 0) {
            $stime = '00:00:01';
            $etime = '-00:00:01';
        } else {
            $timeBefor--;
            $t = sprintf('%02d', $timeBefor);
            $stime = "-00:$t:00";
            $etime = "00:$t:00";
        }

        foreach ($models as $r) {
            $room_id = $r['id'];
            $room_name = $r['name'];
            $sit_amount = $r['sit_amount'];
            $place = $r['place'];
            $room_status = $r['status'];

            $sql = "select status from tb_reserv where (room_id='" . $room_id . "')";
            $sql .= " AND (";
            $sql .= " (ADDTIME(start_date, '$stime' ) between '" . $filter['start_date'] . "' AND '" . $filter['end_date'] . "')";
            $sql .= " OR (ADDTIME(end_date, '$etime') between '" . $filter['start_date'] . "' AND '" . $filter['end_date'] . "')";
            $sql .= " OR ('" . $filter['start_date'] . "' between ADDTIME(start_date, '$stime' ) AND ADDTIME(end_date, '$etime'))";
            $sql .= " OR ('" . $filter['end_date'] . "' between ADDTIME(start_date, '$stime' ) AND ADDTIME(end_date, '$etime'))";
            $sql .= ")";

            $rows = Yii::app()->db->createCommand($sql)->queryAll();

            $status = '0';  //0=ว่าง, 1=ไม่ว่าง สถานะที่ค้นได้ใน tbreserv
            $reserv_status = 4;   //เพื่อเก็บสถานะว่าไม่ว่างเพราะอะไร แต่จะเอารายการหลังสุด
            foreach ($rows as $rw) {
                if ($rw['status'] == '0' || $rw['status'] == '1' || $rw['status'] == '2' || $rw['status'] == '9') {
                    $status = '1';
                    $reserv_status = $rw['status'];   //เพื่อเก็บสถานะว่าไม่ว่างเพราะอะไร แต่จะเอารายการหลังสุด
                }
            }

            $sql = "insert into tmp_roombusy (room_id,room_name,sit_amount,place,room_status,status,reserv_status)";
            $sql .= " values ('$room_id','$room_name','$sit_amount','$place','$room_status','$status','$reserv_status')";

            if ($filter['txtstatus'] == '0' && $status == '0' && $room_status == '0') {
//ว่าง
                Yii::app()->db->createCommand($sql)->execute();
            } else if ($filter['txtstatus'] == '1' && $status == '1' || $room_status != '0') {
//ไม่ว่าง
                Yii::app()->db->createCommand($sql)->execute();
            } else if ($filter['txtstatus'] == '99') {
//ทุกสถานะ
                Yii::app()->db->createCommand($sql)->execute();
            }
        }

        $sql = "select * from tmp_roombusy";
        if ($filter['place'] != '') {
            $sql .= " Where (place = '" . $filter['place'] . "')";
        }
        $count = Yii::app()->db->createCommand($sql)->execute();

        $pages = new CPagination($count);
        $pages->route = 'ajaxListRoom';

        $pageLimit = Yii::app()->params['pageSize'];
        if ($offset > 0) {
            $recordStart = ($offset * $pageLimit) - $pageLimit;
        } else {
            $recordStart = 0;
        }

        $pages->pageSize = $pageLimit;
        $sql .= " Order By room_name asc";
        $sql .= " limit $recordStart,$pageLimit";
        $models = Yii::app()->db->createCommand($sql)->queryAll();
        return array('models' => $models, 'pages' => $pages, 'count' => $count);
    }

    public function actionCreateDoc() {
        $model = new Reserv;
        $model->docno = Docprefix::model()->getDocrun(1);
        $model->room_id = $_POST['room_id'];
        $model->docdate = date('Y-m-d');
        $model->doctime = date('H:i');
        $model->start_date = MyDate::dateToMySql($_POST['start_date']) . " " . $_POST['ddlStartH'] . ":" . $_POST['ddlStartM'];
        $model->end_date = MyDate::dateToMySql($_POST['end_date']) . " " . $_POST['ddlEndH'] . ":" . $_POST['ddlEndM'];

        $user = User::model()->findByPk(Yii::app()->user->id);
        $model->person_name = $user->title . $user->firstname . " " . $user->surname;
        $model->depart_id = $user->depart_id;
        $model->tel = $user->tel;

        $minute = MyDate::compareDate(array('begin' => $model->start_date, 'end' => $model->end_date), false);
        $room = Room::model()->findByPk($_POST['room_id']);
        $model->room_rate = $room->rate;
        $model->room_money = $room->rate * $minute;
        $model->status = '9';
        $model->user_save_id = Yii::app()->user->id;
        $model->date_create = date('Y-m-d H:i:s');

        $company = Company::model()->find();
        $model->time_expire = date('Y-m-d H:i:s', strtotime("+$company->reserv_minute min"));  //เวลาหมดอายุทำรายการจอง

        $busy = Reserv::model()->validateRoomBusy($model->room_id, $model->start_date, $model->end_date);
        if ($busy != '99') {
            $msgText = "ห้องที่เลือกได้ถูกจองไปเมื่อไม่นานนี้ และอยู่ในขั้นตอน <strong><u>" . Reserv::model()->getStatusText($busy) . "</u></strong><br/>จึงไม่สามารถจองได้ คุณต้องเลือกห้องประชุมใหม่";
            Yii::app()->user->setFlash('text_error', $msgText);
            $this->redirect(array('reserv/create'));
        } else {
            $model->save();
            $this->redirect(array('update', 'id' => $model->id));
        }
    }

    public function actionAjaxValidate() {
        $model = new Reserv;
        $data = $model->checkDuplicate($_POST['id'], $_POST['code']);
        echo CJSON::encode($data);
    }

    public function actionUpdate() {
        if (isset($_GET['id'])) {
            $model = Reserv::model()->findByPk((int) $_GET['id']);
            if ($model === NULL) {
                Yii::app()->user->setFlash('success', 'ไม่พบรายการจอง หรือรายการจองนี้หมดเวลาในการบันทึกข้อมูล');
                $this->redirect(array('/reserv'));
                Yii::app()->end();
            }
        }

        if (isset($_POST['Reserv'])) {
//submit มาจาก form
            $model = Reserv::model()->findByPk($_POST['id']);
            if ($model === NULL) {
                Yii::app()->user->setFlash('success', 'ไม่พบรายการจอง หรือรายการจองนี้หมดเวลาในการบันทึกข้อมูล');
                $this->redirect(array('/reserv'));
                Yii::app()->end();
            }

            $model->date_edit = date('Y-m-d H:i:s');

            for ($i = 1; $i < 5; $i++) {
                if (isset($_FILES["file$i"])) {
                    $dir = Yii::getPathOfAlias("webroot.fileupload.filemeeting");
                    $uploadedFile = CUploadedFile::getInstanceByName("file$i");
                    if ($uploadedFile !== null) {
                        $extName = $uploadedFile->getExtensionName();
                        if ($extName == 'php' || $extName == 'js' || $extName == 'exe' || $extName == 'bat') {
                            Yii::app()->user->setFlash('save_error', 'ไฟล์ที่อัพโหลดมีนามสกุลที่ต้องห้าม!..');
                            $this->redirect(array('update', 'id' => $model->id));
                            Yii::app()->end();
                        }

                        $org_name = explode('.', $uploadedFile->getName());
                        $new_name = $model->id . "_$i." . $extName;  //เปลี่ยนชื่อไฟล์

                        $uploadedFile->saveAs($dir . '/' . $new_name);
                        $file = "file$i";
                        $fileName = "file$i" . '_name';

                        $model->$fileName = $org_name[0] . ".$extName";
                        $model->$file = $new_name;
                    }
                }
            }

            $model->attributes = $_POST['Reserv'];
            $model->docdate = date('Y-m-d');
            $model->doctime = date('H:i');
            $model->user_save_id = Yii::app()->user->id;
            $model->room_rate = MyFn::numberToMySql($model->room_rate);
            $model->room_money = MyFn::numberToMySql($model->room_money);
            $model->approve_auto = '0';

//กรณีตั้งระบบอนุมัติ auto และเลือกตัวเลือกส่งเรื่องทันทีเมื่อบันทึก
            if ($model->status == '0') {
                $company = Company::model()->find();
                if ($company->approve_auto == '1') {
                    $model->status = '2';
                    $model->approve_auto = '1';
                    $model->read_date = date('Y-m-d H:i:s');
                    $model->approve_date = date('Y-m-d H:i:s');
                    $model->user_approve_id = Yii::app()->user->id;
                    $model->approve_comment = 'ระบบอนุมัติจองอัตโนมัติ';
                }
            }

            if ($model->room_id == '') {
                $model->save_status = 1;
            } else {
                $model->save_status = 0;
            }

            if ($model->save()) {
                Yii::app()->user->setFlash('success', 'บันทึกข้อมูลเรียบร้อย');
                $this->redirect(array('/reserv'));
            } else {
                Yii::app()->user->setFlash('save_error', $model->getErrors());
                $this->redirect(array('update', 'id' => $model->id));
            }
        }
        $this->render('form', array('model' => $model));
    }

    public function actionAjaxDelete() {
        $id = (int) $_POST['id'];
        $msg = '0';
        $row = Reserv::model()->findByPk($id);

        $end_date = $row->end_date;
        if ($row->delete()) {
            $orders = EquipOrder::model()->findAll(array("condition" => "reserv_id='$id'"));
            foreach ($orders as $order) {
                if ($order->return_stock == 0) {
                    Equip::model()->increment($order->equip_id, $order->amount);
                }
                EquipOrder::model()->deleteByPk($order->id);
            }

            Reserv::model()->deleteFile($id);
        }
        $data['msg'] = $msg;
        echo CJSON::encode($data);
    }

//ลบไฟล์แนบ
    public function actionAjaxDeleteFile() {
        $id = (int) $_POST['id'];
        $fileNumber = $_POST['fileNumber'];

        $file = "file$fileNumber";
        $fileName = "file$fileNumber" . "_name";
        $model = Reserv::model()->findByPk($id);

        if ($model !== NULL) {
            $model->$file = '';
            $model->$fileName = '';
            if ($model->save()) {
                Reserv::model()->deleteFile($id, $file);
            }
        }

        echo true;
    }

//เลือกอุปกรณ์ที่ต้องการใช้ในห้องประชุม
    public function actionAjaxListEquipOrder() {
        $id = (int) $_POST['reserv_id'];
        $grids = $this->getGridData($id);
        $this->renderPartial('_gridview_equip_order', array('grids' => $grids));
    }

    public function getGridEquipOrder($reservID = '') {
        $criteria = new CDbCriteria;
        $criteria->with = array(
            'equip' => array(
                'together' => true,
            ),
        );
        $criteria->condition = "t.reserv_id  = $reservID";
        $models = EquipOrder::model()->findAll($criteria);

        return array('models' => $models);
    }

}
