<?php

/* ยกเลิกจอง */

class ReservcancelController extends AdmController {

    protected function beforeAction($action) {
        if (parent::beforeAction($action)) {
            Yii::app()->session['sidebar_active'] = 'reservCancel';
            return true;
        }
        return false;
    }

    public function actionIndex() {
        $recancel_txt = Yii::app()->session['recancel_txt'];          //id ห้องประชุม
        $recancel_start_date = Yii::app()->session['recancel_start_date'];      //จากวันใช้งาน
        $recancel_end_date = Yii::app()->session['recancel_end_date'];      //ถึงวันที่ใช้งาน

        $grids = $this->getGridData($recancel_txt, $recancel_start_date, $recancel_end_date);
        $this->render('index', array('grids' => $grids,
            'txtsearch' => $recancel_txt,
            'start_date' => $recancel_start_date,
            'end_date' => $recancel_end_date));
    }

    public function actionAjaxList() {
        $offset = (isset($_GET['page'])) ? $_GET['page'] : 0;

        Yii::app()->session['recancel_txt'] = $_POST['txtsearch'];
        Yii::app()->session['recancel_start_date'] = $_POST['start_date'];
        Yii::app()->session['recancel_end_date'] = $_POST['end_date'];

        $grids = $this->getGridData($_POST['txtsearch'], $_POST['start_date'], $_POST['end_date'], $offset);
        $this->renderPartial('_gridview', array('grids' => $grids));
    }

    public function getGridData($recancel_txt = '', $recancel_start_date = '', $recancel_end_date = '', $offset = 0) {
        $sql = "SELECT tb_reserv.id, tb_reserv.docno, tb_reserv.docdate, tb_reserv.doctime,";
        $sql.= " tb_reserv.start_date, tb_reserv.end_date, tb_reserv.status,";
        $sql.= " tb_room.name as room_name, tb_reserv.person_name, ";
        $sql.= " tb_reserv.title, tb_reserv.status FROM tb_reserv ";
        $sql.= " LEFT JOIN tb_room ON tb_reserv.room_id = tb_room.id";
        $sql.= " Where user_save_id='" . Yii::app()->user->id . "'";
        $sql.= " AND (tb_room.name LIKE '%$recancel_txt%' or tb_reserv.title LIKE '%$recancel_txt%')";
        $sql.= " AND tb_reserv.status='2' AND tb_reserv.cancel_doc='0'";

        $recancel_start_date = MyDate::dateToMysql($recancel_start_date);
        $recancel_end_date = MyDate::dateToMysql($recancel_end_date);
        if ($recancel_start_date == '')
            $recancel_start_date = '0000-00-00';
        if ($recancel_end_date == '')
            $recancel_end_date = '3000-01-01';

        $sql.= " AND (";
        $sql.= " (date(tb_reserv.start_date) between '$recancel_start_date' AND '$recancel_end_date')";
        $sql.= " OR (date(tb_reserv.end_date) between '$recancel_start_date' AND '$recancel_end_date')";
        $sql.= " OR ('$recancel_start_date' between date(tb_reserv.start_date) AND date(tb_reserv.end_date))";
        $sql.= " OR ('$recancel_end_date' between date(tb_reserv.start_date) AND date(tb_reserv.end_date))";
        $sql.= ")";

        $count = Yii::app()->db->createCommand($sql)->execute();

        $pages = new CPagination($count);
        $pages->route = 'ajaxList';

        $pageLimit = Yii::app()->params['pageSize'];

        if ($offset > 0) {
            $recordStart = ($offset * $pageLimit) - $pageLimit;
        } else {
            $recordStart = 0;
        }

        $pages->pageSize = $pageLimit;
        $sql.= " Order By tb_reserv.start_date desc, tb_reserv.docno desc";
        $sql.= " limit $recordStart,$pageLimit";
        $models = Yii::app()->db->createCommand($sql)->queryAll();
        return array('models' => $models, 'pages' => $pages, 'count' => $count);
    }

    public function actionUpdate() {
        $id = (isset($_GET['id'])) ? (int) $_GET['id'] : '';
        $model = Reserv::model()->findByPk($id);

        if (isset($_POST['Reserv'])) {
            $model = Reserv::model()->findByPk($_POST['id']);

            $model->attributes = $_POST['Reserv'];

            if ($model->cancel_doc == '1') {
                $model->date_edit = date('Y-m-d H:i:s');

                $txtsave = 'ส่งเรื่องยกเลิกเรียบร้อย';
                //กรณีตั้งระบบอนุมัติ auto จะยกเปลี่ยนสถานะเป็นยกเลิกทันที

                $company = Company::model()->find();
                if ($company->cancel_auto == '1') {
                    $model->status = '4';
                    
                    //เปลี่ยนวันที่เป้นวันที่ปัจจุบัน เพื่อประโยชน์ในการอัพเดท stock  อุปกรณ์
                    $now = date('Y-m-d H:i:s');
                    Yii::app()->db->createCommand("update tb_equip_order set end_date='$now' where reserv_id='$id'")->execute();
                    $txtsave = 'ระบบได้ยกเลิกรายการจองเรียบร้อย';
                }
            } else {
                $txtsave = 'บันทึกข้อมูลเรียบร้อย';
            }

            if ($model->save()) {
                Yii::app()->user->setFlash('success', $txtsave);
                $this->redirect(array('/reservcancel'));
            } else {
                Yii::app()->user->setFlash('save_error', $model->getErrors());
                $this->redirect(array('update', 'id' => $model->id));
            }
        }
        $this->render('form', array('model' => $model));
    }

}
