<?php

class RoomtableController extends Controller {

    protected function beforeAction($action) {
        if (parent::beforeAction($action)) {
            Yii::app()->session['sidebar_active'] = 'roomtable';
            return true;
        }
        return false;
    }

    public function actionIndex() {
        Yii::app()->session['sidebar_active'] = 'roomtable';
        if (!isset(Yii::app()->session['roomtable_start_date'])) {
            $start_date = MyDate::dateToText(date('Y-m-d'));
        } else {
            $start_date = Yii::app()->session['roomtable_start_date'];
        }

        $tbl = $this->getGridData($start_date);
        $this->render('//query/roomtable', array('tbl' => $tbl, 'start_date' => $start_date));
    }

    public function actionAjaxList() {
        $start_date = $_POST['start_date'];
        Yii::app()->session['roomtable_start_date'] = $start_date;


        $tbl = $this->getGridData($start_date);
        $this->renderPartial('//query/_gridview_roomtable', array('tbl' => $tbl));
    }

    public function getGridData($start_date = '', $offset = 0) {
        $start_date = MyDate::dateToMysql($start_date);

        
        $tbl = '';
        $rooms = Room::model()->findAll(array('order' => 'name asc'));
        foreach ($rooms as $room) {
            $sql = "SELECT tb_reserv.id, tb_reserv.docno, tb_reserv.docdate, tb_reserv.doctime,";
            $sql.= " tb_reserv.start_date, tb_reserv.end_date, tb_reserv.status, tb_reserv.read_date, tb_reserv.approve_date,";
            $sql.= " tb_reserv.person_name, tb_reserv.room_id, ";
            $sql.= " tb_reserv.title, tb_reserv.status, tb_depart.name as depart_name FROM tb_reserv ";
            $sql.= " LEFT JOIN tb_depart ON tb_reserv.depart_id = tb_depart.id";
            $sql.= " Where (tb_reserv.room_id = '$room->id') ";
            $sql.= " AND (tb_reserv.status = '0' or tb_reserv.status='1' or tb_reserv.status='2' or tb_reserv.status='9')";
            $sql.= " AND (";
            $sql.= " (date(tb_reserv.start_date) between '$start_date' AND '$start_date')";
            $sql.= " OR (date(tb_reserv.end_date) between '$start_date' AND '$start_date')";
            $sql.= " OR ('$start_date' between date(tb_reserv.start_date) AND date(tb_reserv.end_date))";
            $sql.= " OR ('$start_date' between date(tb_reserv.start_date) AND date(tb_reserv.end_date))";
            $sql.= ")";
            $sql.= " Order By tb_reserv.start_date, tb_reserv.end_date";
            $models = Yii::app()->db->createCommand($sql)->queryAll();

            $imagePath = Room::model()->getImagePath($room->id, "picture1");
            $tbl.="
<div class='block-flat block-info'>
    <div class='header'>
        <div class='media'>
            <div class='media-left'>
                <img src='$imagePath' class='img-responsive' style='width: 100px;'/>
            </div>
            <div class='media-body'>
                <h4 class='media-heading'>$room->name</h4>
                <p><strong>จำนวนที่นั่ง </strong>$room->sit_amount <strong>ที่นั่ง</strong><br/><strong>อาคาร/สถานที่ </strong>$room->place</p>
            </div>
        </div>
    </div>";

            $tbl.='
    <div class="content">            
    <table class="table table-bordered th-bg hover" id="mytable">            
        <thead>
            <tr>
                <th class="text-center" width="110">วันที่ใช้ห้อง</th>
                <th class="text-center">วาระการประชุม</th>
                <th width="100" class="text-center">สถานะ</th>
                <th width="200" class="text-center">แผนกที่ขอใช้</th>
                <th width="100" class="text-center"></th>
            </tr>
        </thead>
        <tbody>';

            $countReserv = 0;
            foreach ($models as $r) {
                $countReserv++;
                $statusText = Reserv::model()->getLabelStatus($r['id']);
                $tbl.="<tr>";
                $tbl.="<td class='nowrap'>";
                $tbl.=MyDate::dateThaiShort($r['start_date']) . " (" . date("H:i", strtotime($r['start_date'])) . ")";
                $tbl.="<br/>" . MyDate::dateThaiShort($r['end_date']) . " (" . date("H:i", strtotime($r['end_date'])) . ")";
                $tbl.="</td>";
                $tbl.="<td>" . $r['title'] . "</td>";
                $tbl.="<td class='text-center'>$statusText</td>";
                $tbl.="<td>" . $r['depart_name'] . "</td>";
                $tbl.='<td class="text-center nowrap">';
                $tbl.='<a href="javascript:void(0);" onclick="return showEventMore(\'' . $r['id'] . '\')" class="label label-info"><i class="fa fa-list-alt"></i> รายละเอียด</a>';
                $tbl.="</td>";
                $tbl.="</tr>";
            }
            if($countReserv==0){
                $tbl.="<tr>";
                $tbl.="<td colspan='5' class='text-center alert-danger'>*** ไม่พบรายการจองใช้ห้องประชุม <b><u>$room->name</u></b> ***</td>";
                $tbl.="</tr>";
            }
            $tbl.='        
        </tbody>
    </table>
    </div>
</div>';
        }       //end foreach room
        return $tbl;
    }

}
