<?php

class UpdatesController extends AdmController {

    protected function beforeAction($action) {
        if (parent::beforeAction($action)) {
            Yii::app()->session['sidebar_active'] = 'updates';
            return true;
        }
        return false;
    }

    public function actionIndex() {
        $model = Company::model()->find();
        $this->render('index', array('model' => $model));
    }

    //ตรวจหาเวอร์ชันใหม่จาก server
    public function actionAjaxCheck() {
        $msg = 0;
        $msgText = 'xxx';
        ini_set('max_execution_time', 60);

        //server version
        $url_server = Yii::app()->params['registerUrl'] . "/updates009/update_roomsys/";
        $v_server = $url_server . 'server_version.php';
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $v_server);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $server_version = trim(curl_exec($ch));
        curl_close($ch);

        $client_version = Yii::app()->params['version'];
        if ($server_version != '') {
            $versionList = explode("\n", $server_version);
            foreach ($versionList as $aV) {
                if (floatval($aV) > floatval($client_version)) {
                    $msg = '1';
                }
            }

            if ($msg == 0) {
                $msgText = "RoomSYS v." . Yii::app()->params['versionText'] . "<br/>โปรแกรมของคุณเป็นเวอร์ชันล่าสุด";
            }
        } else {
            $msg = '0';
            $msgText = "<div class='alert alert-warining'>ไม่สามารถเชื่อมต่อกับ Server ของ " . Yii::app()->params['registerUrl'] . " ได้</div>";
        }

        $data = array(
            'msg' => $msg,
            'msgText' => $msgText,
        );

        echo CJSON::encode($data);
    }

    //เริ่มการอัพเดท
    public function actionAjaxUpdate() {
        $msgText = '';
        ini_set('max_execution_time', 60);

        //server version
        $url_server = Yii::app()->params['registerUrl'] . "/updates009/update_roomsys/";
        $v_server = $url_server . 'server_version.php';
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $v_server);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        $server_version = trim(curl_exec($ch));
        curl_close($ch);

        $client_version = Yii::app()->params['version'];
        $last_version = $client_version;
        if ($server_version != '') {

            //echo '<p>CURRENT VERSION: ' . $client_version . '</p>';
            //echo '<p>Reading Current Releases List</p>';
            $versionList = explode("\n", $server_version);
            foreach ($versionList as $aV) {
                $aV = trim($aV);
                if (floatval($aV) > floatval($client_version)) {
                    $bfile = Yii::getPathOfAlias("webroot.updates") . '/roomsys-' . $aV . '.zip';
                    //if (!file_exists($bfile)) {
                    $file_download = $url_server . "roomsys-" . $aV . ".zip";
                    if (file_put_contents($bfile, file_get_contents($file_download))) {
                        $zip = new ZipArchive;
                        if ($zip->open($bfile) === TRUE) {
                            $zip->extractTo(realpath('./'));
                            $zip->close();

                            //ขั้นตอนการปรับปรุงฐานข้อมูล
                            $phpsqlFile = Yii::getPathOfAlias("webroot.updates") . '/phpsql-' . $aV . '.php';
                            if (file_exists($phpsqlFile)) {
                                require $phpsqlFile;
                            }

                            $last_version = $aV;
                            $sql = "update tb_company set en5='$last_version'";
                            Yii::app()->db->createCommand($sql)->execute();
                        } else {
                            $msgText.="ไม่สามารถอัพเดทเวอร์ชัน $aV /n ได้";
                        }
                    }

                    //}
                }
            }

            Yii::app()->user->setFlash('success', "<strong>RoomSYS </storng> ได้ถูกปรับปรุงเป็นเวอร์ชัน $last_version ล่าสุดแล้ว");
        }

        $data = array(
            'msgText' => $msgText,
        );

        echo CJSON::encode($data);
    }

    //เริ่มการอัพเดท
    public function actionAjaxUpdateManual() {
        $msgText = '';
        ini_set('max_execution_time', 60);

        //ขั้นตอนการปรับปรุงฐานข้อมูล
        $phpsqlFile = Yii::getPathOfAlias("webroot.updates") . '/phpsql-last.php';

        if (file_exists($phpsqlFile)) {
            require $phpsqlFile;
        }

        $model = Company::model()->find();
        Yii::app()->user->setFlash('success', "<strong>RoomSYS </storng> ได้ถูกปรับปรุงเป็นเวอร์ชัน $model->en5 ล่าสุดแล้ว");
        $data = array(
            'msgText' => $msgText,
        );

        echo CJSON::encode($data);
    }

}
