<?php

/*
 * ใบรายงานฟังก์ชัน
 */

class RptfunctionsheetController extends AdmController {

   protected function beforeAction($action) {
        if (parent::beforeAction($action)) {
            Yii::app()->session['sidebar_active'] = 'report';

            if (!isset(Yii::app()->session['rptfunctionsheet_start_date'])) {
                Yii::app()->session['rptfunctionsheet_start_date'] = MyDate::dateToText(date('Y-m-d'));
                Yii::app()->session['rptfunctionsheet_end_date'] = MyDate::dateToText(date('Y-m-d'));
            }
            Yii::app()->session['report_tab'] = 'tab1';
            return true;
        }
        return false;
    }

    //รายงานจองใช้รถ
    public function actionIndex() {
        $start_date = Yii::app()->session['rptfunctionsheet_start_date'];
        $end_date = Yii::app()->session['rptfunctionsheet_end_date'];

        $this->render('//reportpage/rptfunctionsheet', array('start_date' => $start_date, 'end_date' => $end_date));
    }

    public function actionPreview() {
        Yii::app()->session['rptfunctionsheet_start_date'] = $_POST['start_date'];
        Yii::app()->session['rptfunctionsheet_end_date'] = $_POST['end_date'];

        $report_file = (int) $_POST['report_file'];
        $start_date = MyDate::dateToMySql($_POST['start_date']);
        $end_date = MyDate::dateToMysql($_POST['end_date']);

       
        $criteria = new CDbCriteria;
        $criteria->condition = "(docdate between '$start_date' AND '$end_date')";
        $criteria->order = 'docdate asc';

        $models = Functionsheet::model()->findAll($criteria);

        $caption = "รายงานใบฟังก์ชัน";
        $tbl = "<div class='caption'>$caption</div>";
        $tbl.= "<div class='caption2'><strong>ระหว่างวันที่</strong> " . MyDate::dateThai($start_date) . " <strong>ถึง</strong> " . MyDate::dateThai($end_date) . "</div>";
        $tbl.= <<<EOD
          <table style="overflow:wrap;font-size:9pt">
          <thead>
          <tr>            
          <th width='80'>วันที่</th>
          <th width='90'>เลขที่ใบฟังก์ชัน</th>
          <th>Organizer / Company</th>
          <th width='80' align='right'>จำนวนเงิน</th>
          <th width='110'>ผู้ออกใบฟังก์ชัน</th>
          <th width='110'>ผู้อนุมัติ</th>
          </tr>
          </thead>
          <tbody>
EOD;
        $irow = 0;
        $total = 0;
        foreach ($models as $r) {
            $irow++;
            $total+=(int)$r->accounts_price;
            $tbl.="<tr>";
            $tbl.="<td align='center'>" . MyDate::dateToText($r->docdate) . "</td>";
            $tbl.="<td align='center' x:str>$r->docno</td>";
            $tbl.="<td>$r->organizer / $r->company</td>";
            $tbl.="<td align='right'>" . number_format($r->accounts_price) . "</td>";
            $tbl.="<td>$r->bookbyname</td>";
            $tbl.="<td>$r->approve</td>";
            $tbl.="</tr>";
        }

        if ($irow > 0) {
            $tbl.="<tr>";
            $tbl.="<td colspan='3' align='right'><b>รวมเงิน</b></td>";
            $tbl.="<td align='right'><b>" . number_format($total) . "</b></td>";
            $tbl.="<td colspan='2'></td>";
            $tbl.="</tr>";
        } else {
            $tbl.="<tr><td colspan='6' align='center'>*** ไม่พบข้อมูลตามเงื่อนไข ***</td></tr>";
        }

        $tbl.="</tbody></table>";
        $rpt = new ReportForm;
        $content = $rpt->getSchoolName();
        $content.= $tbl;

        if ($report_file == '1') {
            $this->renderPartial("//layouts/report_html_a4", array('content' => $content, 'report_name' => 'รายงาน'));
        } else if ($report_file == '2') {
            $mpdf = $rpt->getMPDF();
            $mpdf->WriteHTML($rpt->getCssPdf(), 1);
            $mpdf->WriteHTML($content, 2);
            $mpdf->Output();
        } else {
            $this->renderPartial('//layouts/report_excel', array('content' => $content, 'report_name' => 'รายงาน'));
        }
    }

}
