<?php

/**
 * This is the model class for table "tb_reserv".
 *
 * The followings are the available columns in table 'tb_reserv':
 * @property integer $id
 * @property string $docno
 * @property string $docdate
 * @property string $doctime
 * @property integer $room_id
 * @property string $start_date
 * @property string $end_date
 * @property string $title
 * @property string $manager
 * @property integer $human_amount
 * @property string $human_name
 * @property string $person_name
 * @property string $tel
 * @property string $equipment
 * @property string $equipment_other
 * @property string $comment
 * @property integer $depart_id
 * @property integer $user_save_id
 * @property string $date_create
 * @property string $date_edit
 * @property integer $status
 * @property string $read_date
 * @property string $approve_date
 * @property string $approve_comment
 * @property integer $save_status
 * @property integer $user_approve_id
 * @property double $room_rate
 * @property double $room_money
 * @property string $file1
 * @property string $file1_name
 * @property string $file2
 * @property string $file2_name
 * @property string $file3
 * @property string $file3_name
 * @property string $file4
 * @property string $file4_name
 * @property integer $public_file
 * @property integer $approve_auto
 * @property integer $cancel_doc
 * @property string $cancel_comment
 * @property string $time_expire
 */
class Reserv extends CActiveRecord {

    /**
     * @return string the associated database table name
     */
    public function tableName() {
        return 'tb_reserv';
    }

    /**
     * @return array validation rules for model attributes.
     */
    public function rules() {
        // NOTE: you should only define rules for those attributes that
        // will receive user inputs.
        return array(
            array('room_id, human_amount, depart_id, user_save_id, status, save_status, user_approve_id, public_file, approve_auto, cancel_doc', 'numerical', 'integerOnly' => true),
            array('room_rate, room_money', 'numerical'),
            array('docno', 'length', 'max' => 20),
            array('doctime', 'length', 'max' => 8),
            array('person_name, tel', 'length', 'max' => 100),
            array('file1, file2, file3, file4', 'length', 'max' => 50),
            array('docdate, start_date, end_date, title, manager, human_name, equipment, equipment_other, comment, date_create, date_edit, read_date, approve_date, approve_comment, file1_name, file2_name, file3_name, file4_name, cancel_comment, time_expire', 'safe'),
            // The following rule is used by search().
            // @todo Please remove those attributes that should not be searched.
            array('id, docno, docdate, doctime, room_id, start_date, end_date, title, manager, human_amount, human_name, person_name, tel, equipment, equipment_other, comment, depart_id, user_save_id, date_create, date_edit, status, read_date, approve_date, approve_comment, save_status, user_approve_id, room_rate, room_money, file1, file1_name, file2, file2_name, file3, file3_name, file4, file4_name, public_file, approve_auto, cancel_doc, cancel_comment, time_expire', 'safe', 'on' => 'search'),
        );
    }

    /**
     * @return array relational rules.
     */
    public function relations() {
        // NOTE: you may need to adjust the relation name and the related
        // class name for the relations automatically generated below.
        return array(
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
            'id' => 'ID',
            'docno' => 'Docno',
            'docdate' => 'Docdate',
            'doctime' => 'Doctime',
            'room_id' => 'Room',
            'start_date' => 'Start Date',
            'end_date' => 'End Date',
            'title' => 'Title',
            'manager' => 'Manager',
            'human_amount' => 'Human Amount',
            'human_name' => 'Human Name',
            'person_name' => 'Person Name',
            'tel' => 'Tel',
            'equipment' => 'Equipment',
            'equipment_other' => 'Equipment Other',
            'comment' => 'Comment',
            'depart_id' => 'Depart',
            'user_save_id' => 'User Save',
            'date_create' => 'Date Create',
            'date_edit' => 'Date Edit',
            'status' => 'Status',
            'read_date' => 'Read Date',
            'approve_date' => 'Approve Date',
            'approve_comment' => 'Approve Comment',
            'save_status' => 'Save Status',
            'user_approve_id' => 'User Approve',
            'room_rate' => 'Room Rate',
            'room_money' => 'Room Money',
            'file1' => 'File1',
            'file1_name' => 'File1 Name',
            'file2' => 'File2',
            'file2_name' => 'File2 Name',
            'file3' => 'File3',
            'file3_name' => 'File3 Name',
            'file4' => 'File4',
            'file4_name' => 'File4 Name',
            'public_file' => 'Public File',
            'approve_auto' => 'Approve Type',
            'cancel_doc' => 'Cancel Type',
            'cancel_comment' => 'Cancel Comment',
            'time_expire'=>'Time Expire',
        );
    }

    /**
     * Retrieves a list of models based on the current search/filter conditions.
     *
     * Typical usecase:
     * - Initialize the model fields with values from filter form.
     * - Execute this method to get CActiveDataProvider instance which will filter
     * models according to data in model fields.
     * - Pass data provider to CGridView, CListView or any similar widget.
     *
     * @return CActiveDataProvider the data provider that can return the models
     * based on the search/filter conditions.
     */
    public function search() {
        // @todo Please modify the following code to remove attributes that should not be searched.

        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('docno', $this->docno, true);
        $criteria->compare('docdate', $this->docdate, true);
        $criteria->compare('doctime', $this->doctime, true);
        $criteria->compare('room_id', $this->room_id);
        $criteria->compare('start_date', $this->start_date, true);
        $criteria->compare('end_date', $this->end_date, true);
        $criteria->compare('title', $this->title, true);
        $criteria->compare('manager', $this->manager, true);
        $criteria->compare('human_amount', $this->human_amount);
        $criteria->compare('human_name', $this->human_name, true);
        $criteria->compare('person_name', $this->person_name, true);
        $criteria->compare('tel', $this->tel, true);
        $criteria->compare('equipment', $this->equipment, true);
        $criteria->compare('equipment_other', $this->equipment_other, true);
        $criteria->compare('comment', $this->comment, true);
        $criteria->compare('depart_id', $this->depart_id);
        $criteria->compare('user_save_id', $this->user_save_id);
        $criteria->compare('date_create', $this->date_create, true);
        $criteria->compare('date_edit', $this->date_edit, true);
        $criteria->compare('status', $this->status);
        $criteria->compare('read_date', $this->read_date, true);
        $criteria->compare('approve_date', $this->approve_date, true);
        $criteria->compare('approve_comment', $this->approve_comment, true);
        $criteria->compare('save_status', $this->save_status);
        $criteria->compare('user_approve_id', $this->user_approve_id);
        $criteria->compare('room_rate', $this->room_rate);
        $criteria->compare('room_money', $this->room_money);
        $criteria->compare('file1', $this->file1, true);
        $criteria->compare('file1_name', $this->file1_name, true);
        $criteria->compare('file2', $this->file2, true);
        $criteria->compare('file2_name', $this->file2_name, true);
        $criteria->compare('file3', $this->file3, true);
        $criteria->compare('file3_name', $this->file3_name, true);
        $criteria->compare('file4', $this->file4, true);
        $criteria->compare('file4_name', $this->file4_name, true);
        $criteria->compare('public_file', $this->public_file);
        $criteria->compare('approve_auto', $this->approve_auto);
        $criteria->compare('cancel_doc', $this->cancel_doc);
        $criteria->compare('cancel_comment', $this->cancel_comment, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    /**
     * Returns the static model of the specified AR class.
     * Please note that you should have this exact method in all your CActiveRecord descendants!
     * @param string $className active record class name.
     * @return Reserv the static model class
     */
    public static function model($className = __CLASS__) {
        return parent::model($className);
    }

    /**
     * ตรวจสอบรหัสซ้ำ
     */
    function checkDuplicate($id, $value) {
        $model = $this->findByAttributes(array('docno' => $value));

        $msg = '0';
        $msgText = '';
        if ($model !== null) {
            if ($model->id != $id) {
                $msgText = "เลขที่เอกสาร $value มีการใช้งานแล้ว...กรุณาเปลี่ยนใหม่.";
                $msg = '1';
            }
        }

        return array('msg' => $msg, 'msgText' => $msgText);
    }

    /*
     * ข้อความสถานะ
     * $status = ค่าสถานะ
     * $des = เลือกแสดงค่าสถานะ
     */

    function getStatusText($status, $des = 0) {
        $ret = '';
        //(0=รออนุมัติ,1=เปิดอ่านแล้ว, 2=อนุมัติ, 3=ไม่อนุมัติ,4=ยกเลิก, 5=ส่งคืนรถแล้ว
        switch ($status) {
            case '9':
                $ret = 'อยู่ระหว่างทำรายการจอง';
                break;
            case '0':
                $ret = 'รออนุมัติ';
                break;
            case '1':
                if ($des == 0) {
                    $ret = 'เปิดอ่านแล้ว';
                } else {
                    $ret = 'รออนุมัติ';
                }
                break;
            case '2':
                if ($des == 0) {
                    $ret = 'อนุมัติ';
                } else {
                    $ret = '';
                }
                break;
            case '3':
                $ret = 'ไม่อนุมัติ';
                break;
            case '4':
                $ret = 'ยกเลิก';
                break;
        }
        return $ret;
    }

    //แสดงสีสถานะการอนุมัติ
    function getLabelStatus($reserv_id) {
        $model = self::model()->findByPk($reserv_id);
        if ($model == null) {
            $status = '9';
        } else {
            $status = $model->status;
        }

        $ret = '';
        //(9=อยู่ระหว่างทำรายการจอง, 0=รออนุมัติ,1=เปิดอ่านแล้ว, 2=อนุมัติ, 3=ไม่อนุมัติ,4=ยกเลิก, 5=ส่งคืนรถแล้ว)
        switch ($status) {
            case '9':
                $ret = '<span class="label label-warning">อยู่ระหว่างทำรายการจอง</span>';
                break;
            case '0':
                $ret = '<span class="label label-warning">รออนุมัติ</span>';
                break;
            case '1':
                $ret = '<span class="label label-info">เปิดอ่านแล้ว</span>';
                break;
            case '2':
                $ret = '<span class="label label-primary">อนุมัติ</span>';
                break;
            case '3':
                $ret = '<span class="label label-danger">ไม่อนุมัติ</span>';
                break;
            case '4':
                $ret = '<span class="label label-default">ยกเลิก</span>';
                break;
        }
        return $ret;
    }

    //แสดงจำนวนรายการรออนุมัติ (ตามผู้อนัติประจำแผนก)
    public function countWating($user_approve_id) {
        $sql = "SELECT tb_reserv.id FROM tb_reserv ";
        $sql.= " INNER JOIN tb_userdepart ON tb_reserv.depart_id = tb_userdepart.depart_id";
        $sql.= " WHERE tb_userdepart.user_id = '$user_approve_id'";
        $sql.= " AND (tb_reserv.status='0' or tb_reserv.status='1')";
        $count = Yii::app()->db->createCommand($sql)->execute();
        return $count;
    }

    //แสดงจำนวนรายการขอยกเลิกรออนุมัติ (ตามผู้อนัติประจำแผนก)
    public function countWatingCancel($user_approve_id) {
        $sql = "SELECT tb_reserv.id FROM tb_reserv ";
        $sql.= " INNER JOIN tb_userdepart ON tb_reserv.depart_id = tb_userdepart.depart_id";
        $sql.= " WHERE tb_userdepart.user_id = '$user_approve_id'";
        $sql.= " AND (tb_reserv.status='2' and tb_reserv.cancel_doc='1')";
        $count = Yii::app()->db->createCommand($sql)->execute();
        return $count;
    }

    //ตรวจสอบสถานะห้องตาม วัน เวลาที่เลือก
    public function validateRoomBusy($room_id, $start_date, $end_date) {
        $timeBefor = 0; //ต้องจองก่อนถึงเวลารถว่าง กี่นาที
        if ($timeBefor == 0) {
            $stime = '00:00:01';
            $etime = '-00:00:01';
        } else {
            $timeBefor--;
            $t = sprintf('%02d', $timeBefor);
            $stime = "-00:$t:00";
            $etime = "00:$t:00";
        }

        $sql = "select status from tb_reserv where room_id='" . $room_id . "'";
        $sql.= " AND (";
        $sql.= " (ADDTIME(start_date, '$stime' ) between '$start_date' AND '$end_date')";
        $sql.= " OR (ADDTIME(end_date, '$etime') between '$start_date' AND '$end_date')";
        $sql.= " OR ('$start_date' between ADDTIME(start_date, '$stime' ) AND ADDTIME(end_date, '$etime'))";
        $sql.= " OR ('$end_date' between ADDTIME(start_date, '$stime' ) AND ADDTIME(end_date, '$etime'))";
        $sql.= ")";

        $row = Yii::app()->db->createCommand($sql)->queryRow();
        $status = '99';
        if (isset($row['status'])) {
            if ($row['status'] == '0' || $row['status'] == '1' || $row['status'] == '2' || $row['status'] == '9') {
                $status = $row['status'];
            }
        }

        return $status;
    }

    //ตรวจสอบว่าไฟล์แนบมีจริงหรือไม่
    public function getFileExist($id, $fieldName) {
        $model = self::model()->findByPk($id);
        $result = false;

        if ($model !== null) {
            if ($model->$fieldName != '') {
                //ตรวจสอบว่ามีภาพนี้อยู่จริงหรือไม่
                Yii::import('application.extensions.cfile.CFile');
                $cfile = new CFile();

                $dir = Yii::getPathOfAlias("webroot.fileupload.filemeeting");
                $myfile = $cfile->set($dir . "/" . $model->$fieldName, true);
                if ($myfile->exists && $myfile->isfile) {
                    $result = true;
                }
            }
        }

        return $result;
    }

    //ลบไฟล์แนบ
    public function deleteFile($id, $fieldName = '') {
        Yii::import('application.extensions.cfile.CFile');
        $dir = Yii::getPathOfAlias("webroot.fileupload.filemeeting");

        $model = self::model()->findByPk($id);
        if ($fieldName == '') {
            //ลบทั้งหมด
            for ($i = 1; $i < 5; $i++) {
                if ($this->getFileExist($id, "file$i")) {
                    $cfile = new CFile();

                    $fileNumber = "file$i";
                    $myfile = $cfile->set($dir . "/" . $model->$fileNumber, true);
                    $myfile->delete();
                }
            }
        } else {
            //ลบไฟล์ที่ระบุ
            if ($this->getFileExist($id, $fieldName)) {
                $cfile = new CFile();
                $myfile = $cfile->set($dir . "/" . $model->$fieldName, true);
                $myfile->delete();
            }
        }

        return true;
    }
    
    //ลบรายการที่ไม่บันทึกจอง (สถานะ 9) หากเกินเวลากำหนดจอง
    public function clearDraft(){
        $now = date('Y-m-d H:i:s');
        $criteria = new CDbCriteria();
        $criteria->condition = "status='9' AND time_expire <= '$now'";
        $models = Reserv::model()->findAll($criteria);
        foreach($models as $r){
            $orders = EquipOrder::model()->findAll(array("condition"=>"reserv_id='$r->id'"));
            foreach ($orders as $order){
                Equip::model()->increment($order->equip_id, $order->amount);
                EquipOrder::model()->deleteByPk($order->id);
                
            }
            
            Reserv::model()->deleteByPk($r->id);
        }
        
        return true;
        
//        $sql = "delete from tb_reserv where status='9' AND time_expire <= '$now'";
//        Yii::app()->db->createCommand($sql)->execute();
    }

}
