<?php
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/jasny-bootstrap/jasny-bootstrap.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/jasny-bootstrap/jasny-bootstrap.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/jasny-bootstrap/jasny-bootstrap-inputmask.js', CClientScript::POS_END);

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/facebox/facebox.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/facebox/facebox.js', CClientScript::POS_END);

$this->pageTitle = Yii::app()->name . ' รายละเอียดการจอง';

$this->breadcrumbs = array(
    'งานรออนุมัติ' => array('/approve'),
    "รายละเอียดการจอง"
);

$classLabel = 'col-sm-2 control-label';
$classDiv = 'col-sm-4';

$equipOrders = EquipOrder::model()->findAll(array("condition" => "reserv_id = '$model->id'"))
?>

<style>
    .div-image-center{
        background-color: #FFF;
        width: 200px;
        height: 150px;
        line-height: 150px;
        text-align: center;
    }
    .dl-horizontal dt{
        padding-bottom: 10px;
    }
</style>

<?php if (Yii::app()->user->hasFlash('success')): ?>
    <script type="text/javascript">
        $(function () {
            $.facebox("<?php echo Yii::app()->user->getFlash('success'); ?>");
        });
    </script>
<?php endif; ?>

<div class="row" id='headRow' style='margin-bottom:5px;'>
    <div class="col-sm-12 col-md-12">

        <div class="block-flat" style='margin-bottom: 5px'>
            <header>
                <span class="widget-icon"> <i class="fa fa-edit"></i></span>
                <h2>รายละเอียดการจอง</h2>	
                <div class="clearfix"></div>
            </header>

            <div class='content'>
                <?php
                $room = Room::model()->findByPk($model->room_id);
                $imagePath = Room::model()->getImagePath($model->room_id, "picture1");
                ?>
                <div class="row" style="margin-bottom:0px">
                    <div class="col-sm-3">
                        <div class="thumbnail">
                            <img src="<?php echo $imagePath; ?>" class="img-responsive">
                        </div>
                    </div>
                    <div class="col-sm-9">
                        <table class="no-border no-strip skills">
                            <tbody class="no-border-x no-border-y">
                                <tr valign='top'>
                                    <td>
                                        <h3 class="name" style="margin-top: 5px"><?php echo $room->name ?></h3>
                                        <div style="font-size:13px">
                                            <?php echo "<strong>จำนวนที่นั่ง </strong>$room->sit_amount  <strong>ที่นั่ง</strong>"; ?>
                                            <br/>
                                            <strong>วันที่ใช้ห้อง </strong> <?php echo MyDate::dateThaiShort($model->start_date) . " เวลา " . date("H:i", strtotime($model->start_date)); ?><br/>
                                            <strong>ถึงวันที่ </strong> <?php echo MyDate::dateThaiShort($model->end_date) . " เวลา " . date("H:i", strtotime($model->end_date)); ?>
                                        </div>
                                    </td>
                                    <td class="nowrap" style="text-align:right">
                                        <?php
                                        echo Reserv::model()->getLabelStatus($model->id);
                                        if ($model->status == '1') {
                                            echo "<p><i class='label label-default'>" . MyDate::dateToText($model->read_date, true) . "</i></p>";
                                        } else if ($model->status > 1) {
                                            echo "<p><i class='label label-default'>" . MyDate::dateToText($model->approve_date, true) . "</i></p>";
                                        }
                                        ?>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
                <hr style="margin-top:0px"/>

                <div class="table-responsive">
                    <table class='table'>
                        <tbody>
                            <tr>
                                <td width='150'><strong>เลขที่ใบจอง</strong></td>
                                <td width='25%'><?php echo $model->docno; ?></td>
                                <td width='130'><strong>วันที่เวลา</strong></td>
                                <td><?php echo MyDate::dateThaiLong($model->docdate) . " <strong>เวลา</strong> " . $model->doctime; ?></td>
                            </tr>
                            <tr>
                                <td><strong>วาระการประชุม</strong></td>
                                <td colspan="3"><?php echo $model->title; ?></td>
                            </tr>
                            <tr>
                                <td><strong>ประธานการประชุม</strong></td>
                                <td colspan="3"><?php echo $model->manager; ?></td>
                            </tr>
                            <tr>
                                <td><strong>จำนวนผู้เข้าประชุม</strong></td>
                                <td colspan="3"><?php echo $model->human_amount; ?></td>
                            </tr>
                            <tr>
                                <td><strong>รายชื่อผู้เข้าประชุม</strong></td>
                                <td colspan="3"><?php echo nl2br($model->human_name); ?></td>
                            </tr>
                            <tr>
                                <td><strong>ใช้สำหรับแผนก</strong></td>
                                <td colspan="3">
                                    <?php
                                    $depart = Depart::model()->findByPk($model->depart_id);
                                    if ($depart != null) {
                                        echo $depart->name;
                                    }
                                    ?>
                                </td>
                            </tr>
                            <tr>
                                <td><strong>ผู้ขอใช้</strong></td>
                                <td><?php echo $model->person_name; ?></td>
                                <td><strong>โทรศัพท์ติดต่อ</strong></td>
                                <td><?php echo $model->tel; ?></td>
                            </tr>
                            <tr>
                                <td><strong>อัตราค่าเช่า</strong></td>
                                <td><?php echo number_format($model->room_rate, 2); ?> <strong> บาท:นาที</strong></td>
                                <td><strong>ค่าเช่าสทุธิ</strong></td>
                                <td><?php echo number_format($model->room_money, 2); ?> <strong> บาท</strong></td>
                            </tr>
                            <tr>
                                <td><strong>อุปกรณ์ที่ต้องการ</strong></td>
                                <td colspan='3'>
                                    <ul>
                                        <?php
                                        foreach ($equipOrders as $ed) {
                                            echo "<li>" . $ed->equip['name'] . "&nbsp;&nbsp;[$ed->amount " . $ed->equip['unitname'] . " " . $ed->description . "]</li>";
                                        }
                                        ?>
                                    </ul>
                                </td>
                            </tr>
                            <tr>
                                <td><strong>เพิ่มเติม</strong></td>
                                <td colspan='3'><?php echo $model->equipment . nl2br($model->comment); ?></td>
                            </tr>
                            <tr>
                                <td><strong>ไฟล์ประกอบ</strong></td>
                                <td colspan='3'>
                                    <?php
                                    $dir = Yii::app()->request->baseUrl . "/fileupload/filemeeting";
                                    for ($i = 1; $i < 5; $i++) {
                                        if (Reserv::model()->getFileExist($model->id, "file$i")) {
                                            $fieldName = "file$i" . "_name";
                                            $field = "file$i";
                                            echo "<div style='margin-bottom:5px'>";
                                            echo '<a href="' . $dir . '/' . $model->$field . '" target="_blank">' . $model->$fieldName . '</a>';
                                            echo "</div>";
                                        }
                                    }
                                    ?>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </div>

            </div>  <!-- end content -->

        </div>  <!-- end block flat -->
    </div>  <!-- end col -->
</div>  <!-- end row -->

<div class="row" id='headRow'>
    <div class="col-sm-12 col-md-12">

        <div class="block-flat">
            <header>
                <span class="widget-icon"> <i class="fa fa-pencil"></i></span>
                <h2>ผลการอนุมัติ สถานะปัจจุบัน <?php echo Reserv::model()->getLabelStatus($model->id);?></h2>	
                <div class="clearfix"></div>
            </header>

            <div class='content'>
                <?php
                $form = $this->beginWidget('CActiveForm', array(
                    'id' => 'myform',
                    'enableClientValidation' => false,
                    'enableAjaxValidation' => false,
                    'htmlOptions' => array(
                        'class' => 'form-horizontal',
                    ),
                    'action' => Yii::app()->createUrl('approve/update'), //<- your form action here
                ));
                ?>

                <div class="alert alert-danger fade in no-margin" style="display:none" id="alert_frm"></div>
                <input type="hidden" id="id" name='id' value="<?php echo $model->id; ?>"/>

                <div class='form-group'>
                    <label class="<?php echo $classLabel; ?>">การอนุมัติ</label>
                    <div class="<?php echo $classDiv; ?>">
                        <select id='booking_status' name='Reserv[status]' class='form-control'>
                            <option value='0' <?php echo($model->status == '0') ? 'selected' : ''; ?>>รออนุมัติ</option>
                            <option value='1' <?php echo($model->status == '1') ? 'selected' : ''; ?>>เปิดอ่านแล้ว</option>
                            <option value='2' <?php echo($model->status == '2') ? 'selected' : ''; ?>>อนุมัติ</option>
                            <option value='3' <?php echo($model->status == '3') ? 'selected' : ''; ?>>ไม่อนุมัติ</option>
                            <option value='4' <?php echo($model->status == '4') ? 'selected' : ''; ?>>ยกเลิก</option>
                        </select>
                    </div>
                </div>

                <div class='form-group'>
                    <label class="<?php echo $classLabel; ?>">วันเวลาอนุมัติ</label>
                    <div class="<?php echo $classDiv; ?>">
                        <input type="text" value='<?php echo MyDate::dateToText($model->read_date, true); ?>' class='form-control' readonly="" tabindex="-1"/>
                    </div>
                </div>

                <div class='form-group'>
                    <label class="<?php echo $classLabel; ?>">หมายเหตุ</label>
                    <div class="col-sm-10">
                        <?php echo $form->textArea($model, 'approve_comment', array('rows' => 2, 'class' => 'form-control')); ?>
                    </div>
                </div>

            </div>  <!-- end content -->

            <?php if ($model->status == '5' || $model->status == '6'): ?>
                <div class='alert alert-info'><h4 style='margin:0px;text-align:center'>รายการจองนี้ได้ทำการ <strong><u><?php echo Reserv::model()->getStatusText($model->status); ?></u></strong> ไม่สามารถแก้ไขการจองได้</h4></div>
            <?php else: ?>
                <div class="form-actions form-actions-gt">
                    <div class="row no-margin">
                        <button type="button" class="btn btn-primary btn-lg" onclick="save();">
                            <i class="fa fa-save"></i>
                            บันทึกผลการอนุมัติ
                        </button>
                    </div>
                </div>
            <?php endif; ?>

            <?php $this->endWidget(); ?>

        </div>  <!-- end block flat -->
    </div>  <!-- end col -->
</div>  <!-- end row -->

<script type='text/javascript'>
    function save() {
        $('#myform').submit();
    }
</script>