<div class="modal-dialog modal-lg">
    <div class="modal-content">
        <div class="modal-header" style='padding:10px;'>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title" id="myModalLabel">รายละเอียดการจอง</h4>
        </div>

        <div class="modal-body">
            <?php
            $room = Room::model()->findByPk($model->room_id);

            $imagePath = Room::model()->getImagePath($model->room_id, "picture1");
            $equipOrders = EquipOrder::model()->findAll(array("condition" => "reserv_id = '$model->id'"));
            ?>
            <div class="row" style="margin-bottom:0px">
                <div class="col-sm-3">
                    <div class="thumbnail">
                        <img src="<?php echo $imagePath; ?>" class="img-responsive">
                    </div>
                </div>
                <div class="col-sm-9">
                    <table class="no-border no-strip skills">
                        <tbody class="no-border-x no-border-y">
                            <tr valign='top'>
                                <td>
                                    <h3 class="name" style="margin-top: 5px"><?php echo $room->name ?></h3>
                                    <div style="font-size:13px">
                                        <?php echo "<strong>จำนวนที่นั่ง </strong>$room->sit_amount  <strong>ที่นั่ง</strong>"; ?>
                                        <br/>
                                        <strong>วันที่ใช้ห้อง </strong> <?php echo MyDate::dateThaiShort($model->start_date) . " เวลา " . date("H:i", strtotime($model->start_date)); ?><br/>
                                        <strong>ถึงวันที่ </strong> <?php echo MyDate::dateThaiShort($model->end_date) . " เวลา " . date("H:i", strtotime($model->end_date)); ?>
                                    </div>
                                </td>
                                <td class="nowrap" style="text-align:right">
                                    <?php
                                    echo Reserv::model()->getLabelStatus($model->id);
                                    if ($model->status == '1') {
                                        echo "<p><i class='label label-default'>" . MyDate::dateToText($model->read_date, true) . "</i></p>";
                                    } else if ($model->status > 1) {
                                        echo "<p><i class='label label-default'>" . MyDate::dateToText($model->approve_date, true) . "</i></p>";
                                    }
                                    ?>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </div>
            </div>

            <table class='table'>
                <tbody>
                    <tr>
                        <td width='150'><strong>เลขที่ใบจอง</strong></td>
                        <td width='25%'><?php echo $model->docno; ?></td>
                        <td width='110'><strong>วันที่เวลา</strong></td>
                        <td><?php echo MyDate::dateThaiLong($model->docdate) . " <strong>เวลา</strong> " . $model->doctime; ?></td>
                    </tr>
                    <tr>
                        <td><strong>วาระการประชุม</strong></td>
                        <td colspan="3"><?php echo $model->title; ?></td>
                    </tr>
                    <tr>
                        <td><strong>ประธานการประชุม</strong></td>
                        <td colspan="3"><?php echo $model->manager; ?></td>
                    </tr>
                    <tr>
                        <td><strong>จำนวนผู้เข้าประชุม</strong></td>
                        <td colspan="3"><?php echo $model->human_amount; ?></td>
                    </tr>
                    <tr>
                        <td><strong>รายชื่อผู้เข้าประชุม</strong></td>
                        <td colspan="3"><?php echo nl2br($model->human_name); ?></td>
                    </tr>
                    <tr>
                        <td><strong>ใช้สำหรับแผนก</strong></td>
                        <td colspan="3">
                            <?php
                            $depart = Depart::model()->findByPk($model->depart_id);
                            if ($depart != null) {
                                echo $depart->name;
                            }
                            ?>
                        </td>
                    </tr>
                    <tr>
                        <td><strong>ผู้ขอใช้</strong></td>
                        <td><?php echo $model->person_name; ?></td>
                        <td><strong>โทรศัพท์ติดต่อ</strong></td>
                        <td><?php echo $model->tel; ?></td>
                    </tr>
                    <tr>
                        <td><strong>อัตราค่าเช่า</strong></td>
                        <td><?php echo number_format($model->room_rate, 2); ?> <strong> บาท:นาที</strong></td>
                        <td><strong>ค่าเช่าสทุธิ</strong></td>
                        <td><?php echo number_format($model->room_money, 2); ?> <strong> บาท</strong></td>
                    </tr>
                    <tr>
                        <td><strong>อุปกรณ์ที่ต้องการ</strong></td>
                        <td colspan='3'>
                            <ul>
                                <?php
                                foreach ($equipOrders as $ed) {
                                    echo "<li>" . $ed->equip['name'] . "&nbsp;&nbsp;[$ed->amount " . $ed->equip['unitname'] . " " . $ed->description . "]</li>";
                                }
                                ?>
                            </ul>
                        </td>
                    </tr>
                    <tr>
                        <td><strong>เพิ่มเติม</strong></td>
                        <td colspan='3'><?php echo nl2br($model->comment); ?></td>
                    </tr>
                    <tr>
                        <td><strong>ไฟล์ประกอบ</strong></td>
                        <td colspan='3'>

                            <?php
                            if ($model->public_file != '0' && Yii::app()->user->isGuest) {
                                echo "<div class='alert alert-warning'><i class='fa fa-warning sign'></i><strong>เตือน!</strong>คุณต้องล็อกอินเข้าสู่ระบบก่อน...จึงจะมองเห็นไฟล์</div>";
                            } else {
                                $dir = Yii::app()->request->baseUrl . "/fileupload/filemeeting";
                                for ($i = 1; $i < 5; $i++) {
                                    if (Reserv::model()->getFileExist($model->id, "file$i")) {
                                        $fieldName = "file$i" . "_name";
                                        $field = "file$i";
                                        echo "<div style='margin-bottom:5px'>";
                                        echo '<a href="' . $dir . '/' . $model->$field . '" target="_blank">' . $model->$fieldName . '</a>';
                                        echo "</div>";
                                    }
                                }
                            }
                            ?>
                        </td>
                    </tr>
                </tbody>
            </table>

        </div>  <!-- end modal body -->
        <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal" name="a"> ปิด </button>
        </div>

    </div>
</div>