<?php
$this->pageTitle = Yii::app()->name . ' ปฏิทินการใช้ห้อง';
$this->breadcrumbs = array(
    'ปฏิทินการใช้ห้อง'
);
?>
<input type='hidden' id='room_id'>
<div class="row">
    <div class="col-sm-12 col-md-12">
        <div class="block-flat">
            <header>
                <span class="widget-icon"> <i class="fa fa-table"></i></span>
                <h2>ปฏิทินการใช้ห้อง</h2>	
                <div class="clearfix"></div>
            </header>

            <div class='content'>
                <div class='row no-margin-bottom'>
                    <div class='col-md-12'>
                        <div class="form-group col-sm-8 col-md-8 padding-small">
                            <div class="input-group">
                                <input type='text' id='room_name' readonly="" class='form-control' style='font-size: 16px'>
                                <span class="input-group-btn">
                                    <button type="button" class="btn btn-default" onclick="roomModal()"><i class="fa fa-building-o"></i>เฉพาะห้องที่ต้องการ</button>
                                    <button type="button" class="btn btn-default" onclick="clearRoom()">แสดงทุกห้อง</button>
                                </span>
                            </div>
                        </div>
                    </div>
                </div>
                
                <div id="divCalendar">
                    <?php $this->renderPartial('_calendar', array('calendar' => $calendar, 'start_date' => $start_date)); ?>
                </div>

                <!-- แสดง grid รายการจองประจำเดือน -->
                <div id="divGridView">
                    <?php $this->renderPartial('_gridview', array('grids' => $grids)); ?>
                </div>
            </div>
        </div>
    </div>
</div>

<!-- Modal รายการจอง -->
<div class="modal fade colored-header" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true" data-backdrop="true">
</div>

<!-- Modal รายละเอียดการจอง-->
<div class="modal fade colored-header" id="myModalDetailMore" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true" data-backdrop="true">
</div>

<?php $this->renderPartial('//room/modalRoom'); ?>

<script type='text/javascript'>
    function loadCalendar(url) {
        url = typeof url !== 'undefined' ? url : "<?php echo Yii::app()->createUrl('/calendar/ajaxCalendar') ?>";

        var p = {};
        p['room_id'] = $('#room_id').val();
        p['start_date'] = $('#start_date').val();

        $('#divCalendar').load(url, p, function () {
            loadGridView();
        });
        return true;
    }

    function loadGridView(url) {
        url = typeof url !== 'undefined' ? url : "<?php echo Yii::app()->createUrl('/calendar/ajaxList') ?>";

        var p = {};
        p['room_id'] = $('#room_id').val();
        p['start_date'] = $('#start_date').val();

        $('#divGridView').load(url, p);
        return true;
    }
    
    function showEvent(start_date) {
        var p = {};
        p['start_date'] = start_date;
        p['room_id'] = $('#room_id').val();
        $('#myModal').load("<?php echo Yii::app()->createUrl('calendar/ajaxDetail') ?>", p, function () {
            $('#myModal').modal('show');
        });
        return true;
    }

    function showEventMore(reserv_id) {
        var p = {};
        p['reserv_id'] = reserv_id;
        $('#myModalDetailMore').load("<?php echo Yii::app()->createUrl('calendar/ajaxDetailMore') ?>", p, function () {
            $('#myModalDetailMore').modal('show');
        });
        return true;
    }
    
    
    //เปิด Modal Room
    function roomModal() {
        loadGridRoomModal();
        $('.modal').on('shown.bs.modal', function () {
            //$('.modal .modal-body').css('height', getModalHeightBody());
            $('#txtsearchRoomModal').focus();
        });
        $('#myModalRoom').modal({show: true});
    }

    //เลือกหมวดจาก modal
    function roomModalSelect(id, code) {
        $('#room_id').val(id);
        $('#room_name').val(code);
        $('#myModalRoom').modal('hide');

        var str = $('#start_date').val();
        var res = str.split("-");
        loadCalendar("<?php echo Yii::app()->createUrl('/calendar/ajaxCalendar') ?>&get_year=" + res[0] + "&get_month=" + res[1] + "&get_date=01");
    }

    function clearRoom() {
        $('#room_id').val('');
        $('#room_name').val('');

        var str = $('#start_date').val();
        var res = str.split("-");
        loadCalendar("<?php echo Yii::app()->createUrl('/calendar/ajaxCalendar') ?>&get_year=" + res[0] + "&get_month=" + res[1] + "&get_date=01");
    }
</script>