<?php
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/jasny-bootstrap/jasny-bootstrap.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/jasny-bootstrap/jasny-bootstrap.js', CClientScript::POS_END);

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/chosen/chosen.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/chosen/chosen-bootstrap.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/chosen/chosen.jquery.min.js');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/jquery.numeric.js', CClientScript::POS_END);

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/facebox/facebox.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/facebox/facebox.js', CClientScript::POS_END);

$this->pageTitle = Yii::app()->name . ' สถานประกอบการ';

$this->breadcrumbs = array(
    "สถานประกอบการ"
);

$classLabel = 'col-sm-3 col-md-3 control-label';
$classDiv = 'col-sm-9 col-md-9';

$this->renderPartial('//layouts/hasFlash');
?>
<style>
    .div-image-center{
        background-color: #FFF;
        width: 150px;
        height: 150px;
        line-height: 150px;
        text-align: center;
    }
    ul.typeahead li a{
        font-size: 14px;
    }
</style>
<div class="row" id='headRow'>
    <div class="col-sm-12 col-md-12">

        <div class="block-flat">
            <header>
                <span class="widget-icon"> <i class="fa fa-edit"></i></span>
                <h2>รายละเอียดสถานประกอบการ</h2>	
                <div class="clearfix"></div>
            </header>

            <div class='content'>
                <?php
                $form = $this->beginWidget('CActiveForm', array(
                    'id' => 'myform',
                    'enableClientValidation' => false,
                    'enableAjaxValidation' => false,
                    'htmlOptions' => array(
                        'class' => 'form-horizontal',
                        'enctype' => 'multipart/form-data',
                    ),
                    'action' => Yii::app()->createUrl('/company'), //<- your form action here
                ));
                ?>

                <div class="alert alert-danger fade in no-margin" style="display:none" id="alert_frm"></div>
                <input type="hidden" id="id" name='id' value="<?php echo $model->id; ?>"/>

                <div class='form-group'>
                    <label class="<?php echo $classLabel; ?>">ชื่อสถานประกอบการ<span class="required">*</span></label>
                    <div class="<?php echo $classDiv; ?>">
                        <?php echo $form->textField($model, 'name', array('class' => 'form-control', 'required' => 'true')); ?>
                    </div>
                </div>

                <div class='form-group'>
                    <label class="<?php echo $classLabel; ?>">ผู้บริหาร<span class="required">*</span></label>
                    <div class="<?php echo $classDiv; ?>">
                        <?php echo $form->textField($model, 'manager', array('class' => 'form-control', 'required' => 'true')); ?>
                    </div>
                </div>

                <div class='form-group'>
                    <label class="<?php echo $classLabel; ?>">ที่อยู่</label>
                    <div class="<?php echo $classDiv; ?>">
                        <?php echo $form->textArea($model, 'address', array('rows' => 2, 'class' => 'form-control')); ?>
                    </div>
                </div>

                <div class='form-group'>
                    <label class="<?php echo $classLabel; ?>">จังหวัด<span class="required">*</span></label>
                    <div class="<?php echo $classDiv; ?>">
                        <select name="Company[province]" data-placeholder="ป้อนหรือคลิกเลือกรายการ" class="chzn-select-deselect form-control" required="" title='คุณต้องเลือกจังหวัด'>
                            <option value=""></option>
                            <?php
                            $provinces = Province::model()->findAll(array('order' => 'name asc'));
                            foreach ($provinces as $r) {
                                $selected = ($model->province == $r->name) ? 'selected' : '';
                                echo "<option value='$r->name' $selected>$r->name</option>";
                            }
                            ?>
                        </select>
                    </div>
                </div>
                
                <div class='form-group'>
                    <label class="<?php echo $classLabel; ?>">โทรศัพท์</label>
                    <div class="<?php echo $classDiv; ?>">
                        <?php echo $form->textField($model, 'tel', array('class' => 'form-control')); ?>
                    </div>
                </div>

                <div class='form-group'>
                    <label class="<?php echo $classLabel; ?>">โทรสาร</label>
                    <div class="<?php echo $classDiv; ?>">
                        <?php echo $form->textField($model, 'fax', array('class' => 'form-control')); ?>
                    </div>
                </div>

                <br/>
                <?php $baseUrl = Yii::app()->request->baseUrl; ?>
                <fieldset>
                    <legend><i class="fa fa-picture-o"></i> โลโก้</legend>
                    <div class="alert alert-info">ขนาดภาพที่เหมาะสมคือ 150 x 150 pixel</div>
                    <?php
                        $imagePath = Company::model()->getImagePath($model->id);
                        ?>
                        <div class="fileinput fileinput-new" data-provides="fileinput" style="margin-left:5px;">
                            <div class="fileinput-new thumbnail div-image-center">
                                <a href='<?php echo $imagePath; ?>' class='fancybox' rel="gallery1" title='โลโก้'>
                                    <img src="<?php echo $imagePath; ?>" alt="โลโก้" class="img-responsive">
                                </a>
                            </div>
                            <div class="fileinput-preview fileinput-exists thumbnail div-image-center"></div>
                            <div>
                                <span class="btn btn-default btn-file"><span class="fileinput-new">เลือกรูปโลโก้</span><span class="fileinput-exists">เปลี่ยน</span><input type="file" name="logo"></span>
                                <a href="#" class="btn btn-default fileinput-exists" data-dismiss="fileinput">ยกเลิก</a>
                            </div>
                        </div>
                </fieldset>
                
                <div class='clearfix'></div>
                <div class="form-actions form-actions-gt">
                    <div class="row no-margin">
                        <button type="submit" class="btn btn-primary btn-lg">
                            <i class="fa fa-save"></i>
                            บันทึกข้อมูล
                        </button>
                    </div>
                </div>

                <?php $this->endWidget(); ?>
            </div>

        </div>

    </div>
</div>

<!-- Modal -->
<div class="modal fade colored-header" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true" data-backdrop="true">
</div>

<script type='text/javascript'>
    $(document).ready(function () {
        $(".chzn-select-deselect").chosen({
            allow_single_deselect: true,
            no_results_text: 'ไม่พบรายชื่อ!',
            search_contains: true
        });

        $('#myform').validate({ignore: ":hidden:not(select)",
            invalidHandler: function (event, validator) {
                loadingStaticRemove();
            }
        });
    });
</script>