<?php
$this->pageTitle = Yii::app()->name . ' รายละเอียดใบงานฟังก์ชัน';
$this->breadcrumbs = array(
    'รายการใบงานฟังก์ชัน' => array('/fsheet'),
    "รายละเอียดใบงานฟังก์ชัน"
);
?>

<div class='block-flat'>
    <div style='padding: 0 4px'>
        <?php if ($model->count_edit > -1): ?>
            <div class="pull-left" style="padding-top: 10px;">
                <span class="label label-primary" style="padding-bottom: 4px;font-size:13px">แก้ไขครั้งที่ <?php echo $model->count_edit; ?></span>
            </div>
        <?php endif; ?>
        <div class="widget-toolbar">
            <a href="javascript:void(0);" onclick='preview(1);' class="btn btn-xs btn-default"><img src='<?php echo Yii::app()->request->baseUrl; ?>/img/page_white.png'/> พิมพ์ใบฟังก์ชัน</a>
        </div>
        <div class="clearfix"></div>
    </div>

    <div class='content' style='padding-top:0px;'>
        <div class='table-responsive'>
            <table class='table table-bordered hover'>
                <tbody>
                    <tr>
                        <td width='120'><strong>FUNCTION NO</strong></td>
                        <td width='300'><h4 class='no-margin'><?php echo $model->docno; ?></h4></td>
                        <td width='120'><strong>DATE OF ISSUE</strong></td>
                        <td><h4 class='no-margin'><?php echo MyDate::dateToText($model->docdate); ?></h4></td>
                    </tr>

                    <tr valign='top'>
                        <td><strong>ORGANIZER</strong></td>
                        <td><h4 class='no-margin'><?php echo $model->organizer; ?></h4></td>
                        <td><strong>BOOKED BY</strong></td>
                        <td><h4 class='no-margin'><?php echo $model->booked_by; ?></h4></td>
                    </tr>

                    <tr valign='top'>
                        <td><strong>COMPANY</strong></td>
                        <td><h4 class='no-margin'><?php echo $model->company; ?></h4></td>
                        <td><strong>TEL.</strong></td>
                        <td><h4 class='no-margin'><?php echo $model->tel; ?></h4></td>
                    </tr>

                    <tr valign='top'>
                        <td><strong>DAY</strong></td>
                        <td colspan='3'><h4 class='no-margin'><?php echo $model->daybook . "&nbsp;&nbsp;&nbsp;&nbsp;<strong>DATE&nbsp;&nbsp;</strong>" . $model->datebook . "&nbsp;&nbsp;&nbsp;&nbsp;<strong>TIME&nbsp;&nbsp;</strong>" . $model->timebook; ?></h4></td>
                    </tr>

                    <tr valign='top'>
                        <td><strong>ROOM</strong></td>
                        <td colspan='3'><h4 class='no-margin'><?php echo $model->room['name']; ?></h4></td>
                    </tr>

                    <tr valign='top'>
                        <td><strong>GURANTEED</strong></td>
                        <td colspan='3'><?php echo $model->guaranteed; ?></td>
                    </tr>

                    <tr valign='top'>
                        <td><strong>ACOOUNT TO</strong></td>
                        <td colspan='3'><?php echo $model->accountto; ?></td>
                    </tr>

                    <tr valign='top'>
                        <td><strong>ADDRESS</strong></td>
                        <td colspan='3'><?php echo $model->address; ?></td>
                    </tr>

                    <tr valign='top'>
                        <td><strong>PRICE</strong></td>
                        <td colspan='3'><?php echo $model->pricetext; ?></td>
                    </tr>

                    <tr valign='top'>
                        <td><strong>COMMENT</strong></td>
                        <td colspan='3'><?php echo $model->comment; ?></td>
                    </tr>

                    <tr valign='top'>
                        <td colspan='2'><strong>TIME TABLE</strong><br/><?php echo $model->timetable; ?></td>
                        <td colspan='2'><strong>ACCOUNTS</strong><br/><?php echo $model->accounts; ?><br/><div style='font-size:16px;font-weight:bold' class="text-danger">รวมค่าใช้จ่าย <?php echo number_format($model->accounts_price); ?> บาท</div></td>
                    </tr>

                    <tr valign='top'>
                        <td colspan='2'><strong>FOOD ARRANGEMENTS</strong><br/><?php echo $model->food_ar; ?></td>
                        <td colspan='2'><strong>SPECIAL FOOD ARRANGEMENTS</strong><br/><?php echo $model->food_sp; ?></td>
                    </tr>

                    <tr valign='top'>
                        <td colspan='2'><strong>BEVERAGE ARRANGEMENTS</strong><br/><?php echo $model->beverage; ?></td>
                        <td colspan='2'><strong>ROOM SETUP</strong><br/><?php echo $model->roomsetup; ?></td>
                    </tr>

                    <tr valign='top'>
                        <td colspan='2'><strong>FLORIST</strong><br/><?php echo $model->florist; ?></td>
                        <td colspan='2'><strong>ARTIST</strong><br/><?php echo $model->artist; ?></td>
                    </tr>

                    <tr valign='top'>
                        <td colspan='2'><strong>AV/LIGHTING</strong><br/><?php echo $model->av; ?></td>
                        <td colspan='2'><strong>P.R.</strong><br/><?php echo $model->pr; ?></td>
                    </tr>

                    <tr valign='top'>
                        <td><strong>ผู้ตรวจสอบ</strong></td>
                        <td><?php echo $model->approve; ?></td>
                        <td><strong>ตำแหน่ง</strong></td>
                        <td><?php echo $model->position; ?></td>
                    </tr>

                    <tr valign='top'>
                        <td><strong>ผู้ออกใบฟังก์ชัน</strong></td>
                        <td><?php echo $model->bookbyname; ?></td>
                        <td><strong>ตำแหน่ง</strong></td>
                        <td><?php echo $model->bookbyposition; ?></td>
                    </tr>

                </tbody>
            </table>
        </div>
 
    </div>
</div>

<div class='block-flat'>
    <div class='content'>
        <h3 class='no-margin'><u>รายการอาหาร</u></h3>
        <div class='row'>
            <?php
            $models = $grids_food['models'];
            $irow = 0;
            foreach ($models as $r) {
                $irow++;
                echo "<div class='col-md-6'>";
                echo "<h4>$r->title</h4>$r->detail";
                echo "</div>";
            }
            if ($irow == 0) {
                echo "<div class='text-center text-danger'>*** ไม่มีรายการอาหาร ***</div>";
            }
            ?>
        </div>
    </div>
</div>

<form action="<?php echo Yii::app()->createUrl('fsheet/preview'); ?>" method="post" id="myreport" target="_blank">
    <input type="hidden" id="report_file" name="report_file" value="0"/> <!-- สำหรับระบุว่าจะออกเป็น hmtl, pdf หรือ excel -->
    <input type="hidden" name="id" value="<?php echo $model->id; ?>"/>
</form>

<?php $this->renderPartial('//room/modalRoom'); ?>
<script type='text/javascript'>
    //พิมพ์ใบฟังก์ชัน
    function preview(report_file) {
        $('#report_file').val(report_file);
        $('#myreport').submit();
    }
</script>