<?php
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/input-mask/jquery.inputmask.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/input-mask/jquery.inputmask.numeric.extensions.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/input-mask/jquery.inputmask.date.extensions.js', CClientScript::POS_END);

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/datepicker3.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/bootstrap-datepicker.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/bootstrap-datepicker-thai.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/locales/bootstrap-datepicker.th.js', CClientScript::POS_END);

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/facebox/facebox.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/facebox/facebox.js', CClientScript::POS_END);

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/bootstrap.wysihtml5/bootstrap3-wysihtml5.min.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap.wysihtml5/wysihtml5-0.3.0.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap.wysihtml5/bootstrap3-wysihtml5.all.min.js', CClientScript::POS_END);
$this->pageTitle = Yii::app()->name . ' รายละเอียดใบงานฟังก์ชัน';

$newORedit = ($model->id == '') ? 'เพิ่ม' : 'แก้ไข';
$this->breadcrumbs = array(
    'รายการใบงานฟังก์ชัน' => array('/functionsheet'),
    "รายละเอียดใบงานฟังก์ชัน ($newORedit)"
);

$this->renderPartial('//layouts/hasFlash');
?>

<div class="tab-container">
    <ul class="nav nav-tabs">
        <li class="active"><a href="#tab1" data-toggle="tab">รายละเอียดใบงานฟังก์ชัน</a></li>
        <li><a href="#tab2" data-toggle="tab">รายการอาหาร</a></li>
    </ul>
    <div class="tab-content" style="padding-top:10px">
        <div class="tab-pane active cont" id="tab1">
            <?php $this->renderPartial('_tab1', array('model' => $model)); ?>
        </div>  <!-- end tab1 -->


        <div class="tab-pane cont" id="tab2">
            <?php if ($model->id == ''): ?>
                <div class="alert alert-warning margin-top-20">
                    <i class="fa fa-warning sign"></i><strong>แจ้งให้ทราบ!</strong> คุณจะต้องบันทึกรายละเอียดใบฟังก์ชันก่อน จึงจะกรอกรายการอาหารได้
                </div>
            <?php else: ?>
                <?php $this->renderPartial('_tab2', array('grids_food' => $grids_food)); ?>
            <?php endif; ?>
        </div>
    </div>
</div>

<form action="<?php echo Yii::app()->createUrl('fsheet/preview'); ?>" method="post" id="myreport" target="_blank">
    <input type="hidden" id="report_file" name="report_file" value="0"/> <!-- สำหรับระบุว่าจะออกเป็น hmtl, pdf หรือ excel -->
    <input type="hidden" name="id" value="<?php echo $model->id;?>"/>
</form>

<?php $this->renderPartial('//room/modalRoom'); ?>
<script type='text/javascript'>
    $(document).ready(function () {

        $('#myform').validate({ignore: ":hidden:not(select)",
            invalidHandler: function (event, validator) {
                loadingStaticRemove();
            }
        });

        $('.modal').on('shown.bs.modal', function () {
            $(this).find("[autofocus]:first").focus();
        });

        $('.html5').wysihtml5({
            "font-styles": false, //Font styling, e.g. h1, h2, etc. Default true
            "html": false, //Button which allows you to edit the generated HTML. Default false
            "link": false, //Button to insert a link. Default true
            "image": false, //Button to insert an image. Default true,
            "color": false,
            "blockquote": false
        });

        $('.numeric').inputmask({
            alias: 'integer',
            groupSeparator: ',',
            autoGroup: true,
            digitsOptional: false,
            placeholder: '0'
        });

        $('.input-group.date').datepicker({
            todayBtn: 'linked',
            language: "th-th",
            keyboardNavigation: true,
            autoclose: true,
            todayHighlight: true,
            format: "dd/mm/yyyy"
        });
        $(".input-group.date input").inputmask("dd/mm/yyyy", {"placeholder": "วว/ดด/ปปปป"});

    });

    function save() {
        var p = {};
        p['save'] = true;
        p['id'] = $('#id').val();
        p['docno'] = $('#Functionsheet_docno').val();

        $.ajax({
            data: p,
            url: "<?php echo Yii::app()->createUrl('functionsheet/ajaxValidate') ?>",
            type: 'POST', dataType: 'json',
            success: function (data) {
                scrollToTop();
                if (data.msg == '0') {
                    loadingStatic();
                    $('#myform').submit();
                } else {
                    bootbox.alert(artalert('danger', data.msgText));
                }
            },
            error: function () {
                bootbox.alert(artalert('danger', 'ไม่สามารถบันทึกข้อมูลได้ กรุณาลองใหม่อีกครั้ง !!'));
            }
        });
        return true;
    }

    function del(id) {
        bootbox.confirm(artalert('warning', 'คุณต้องการลบข้อมูลรายการนี้ ใช่หรือไม่!!'), function (result) {
            if (result) {
                var p = {};
                p['id'] = id;
                $.ajax({
                    data: p,
                    url: "<?php echo Yii::app()->createUrl('functionsheet/ajaxDelete') ?>",
                    type: 'POST',
                    dataType: 'json',
                    success: function () {
                        window.location.href = "<?php echo Yii::app()->createUrl('functionsheet/create'); ?>"
                    },
                    error: function () {
                        bootbox.alert(artalert('danger', 'ไม่สามารถทำรายการได้ กรุณาลองใหม่อีกครั้ง !!'));
                    }
                });
            }
        });

        return true;
    }

    function docrun() {
        $.ajax({
            url: "<?php echo Yii::app()->createUrl('functionsheet/ajaxDocRun') ?>",
            type: 'POST',
            dataType: 'json',
            success: function (data) {
                $('#Functionsheet_docno').val(data.docno);
            },
            error: function (xhr, ajaxOptions, thrownError) {
                bootbox.alert(artalert('danger', xhr.responseText + '\n' + xhr.status + '\n' + thrownError));
            }
        });
        return true;
    }

    //เปิด Modal Room
    function roomModal() {
        loadGridRoomModal();
        $('.modal').on('shown.bs.modal', function () {
            $('#txtsearchRoomModal').focus();
        });
        $('#myModalRoom').modal({show: true});
    }

    //เลือกหมวดจาก modal
    function roomModalSelect(id, code) {
        $('#Functionsheet_room_id').val(id);
        $('#room_name').val(code);
        $('#myModalRoom').modal('hide');
    }

    //======== Food ============//

    function loadGridViewFood() {
        var p = {};
        p['functionsheet_id'] = $('#id').val();
        $('#div_grid_food').load("<?php echo Yii::app()->createUrl('functionsheet/ajaxListFood') ?>", p);
        return true;
    }

    function updateFood(id, copy) {
        var p = {};
        p['id'] = id;
        $.ajax({
            data: p,
            url: "<?php echo Yii::app()->createUrl('functionsheet/ajaxUpdateFood') ?>",
            type: 'POST',
            dataType: 'json',
            success: function (data) {
                if (copy == 'false') {
                    $('#food_statustext').text('รายการแก้ไข');
                    $('#food_id').val(data.id);
                } else {
                    $('#food_statustext').text('รายการคัดลอก');
                    $('#food_id').val('');
                }
                $('#food_no').val(data.no);
                $('#food_title').val(data.title);
                $("#food_detail").data("wysihtml5").editor.setValue(data.detail);
            },
            error: function (xhr, ajaxOptions, thrownError) {
                bootbox.alert(artalert('danger', xhr.responseText + '\n' + xhr.status + '\n' + thrownError));
            }
        });
        return true;
    }

    function saveFood() {
        var p = {};
        p['save'] = true;
        p['id'] = $('#food_id').val();
        p['functionsheet_id'] = $('#id').val();
        p['title'] = $('#food_title').val();
        p['detail'] = $('#food_detail').val();
        p['no'] = $('#food_no').val();

        $.ajax({
            data: p,
            url: "<?php echo Yii::app()->createUrl('functionsheet/ajaxSaveFood') ?>",
            type: 'POST',
            dataType: 'json',
            success: function () {
                loadGridViewFood();
                clearFood();
            },
            error: function (xhr, ajaxOptions, thrownError) {
                bootbox.alert(artalert('danger', xhr.responseText + '\n' + xhr.status + '\n' + thrownError));
            }
        });
        return true;
    }

    function delFood(id) {
        bootbox.confirm(artalert('warning', 'คุณต้องการลบข้อมูลรายการนี้ ใช่หรือไม่!!'), function (result) {
            if (result) {
                var p = {};
                p['id'] = id;
                $.ajax({
                    data: p,
                    url: "<?php echo Yii::app()->createUrl('functionsheet/ajaxDeleteFood') ?>",
                    type: 'POST',
                    dataType: 'json',
                    success: function () {
                        loadGridViewFood();
                    },
                    error: function (xhr, ajaxOptions, thrownError) {
                        bootbox.alert(artalert('danger', xhr.responseText + '\n' + xhr.status + '\n' + thrownError));
                    }
                });
            }
        });

        return true;
    }

    function clearFood() {
        $('#food_statustext').text('รายการเพิ่มใหม่');
        $('#food_id').val('');
        $('#food_no').val('1');
        $('#food_title').val('');
        $("#food_detail").data("wysihtml5").editor.setValue('');
    }
    
    //พิมพ์ใบฟังก์ชัน
    function preview(report_file) {
        $('#report_file').val(report_file);
        $('#myreport').submit();
    }
</script>