<?php
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/input-mask/jquery.inputmask.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/input-mask/jquery.inputmask.date.extensions.js', CClientScript::POS_END);

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/datepicker3.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/bootstrap-datepicker.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/bootstrap-datepicker-thai.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/locales/bootstrap-datepicker.th.js', CClientScript::POS_END);

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/facebox/facebox.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/facebox/facebox.js', CClientScript::POS_END);
$this->pageTitle = Yii::app()->name . ' ใบงานฟังก์ชัน';
$this->breadcrumbs = array(
    'ใบงานฟังก์ชัน'
);
?>

<?php if (Yii::app()->user->hasFlash('success')): ?>
    <script type="text/javascript">
        $(function () {
            $.facebox("<?php echo Yii::app()->user->getFlash('success'); ?>");
        });
    </script>
<?php endif; ?>

<div class="row">
    <div class="col-sm-12 col-md-12">
        <div class="block-flat">
            <header>
                <span class="widget-icon"> <i class="fa fa-table"></i></span>
                <h2>ใบงานฟังก์ชัน</h2>
                <div class="widget-toolbar">
                    <?php echo CHtml::link('<i class="fa fa-plus"></i> เพิ่มข้อมูล', array('functionsheet/create'), array('class' => 'btn btn-xs btn-success')); ?>
                </div>
                <div class="clearfix"></div>
            </header>

            <div class='content'>
                <div class="row">
                    <div class="col-sm-8 col-md-6 col-lg-5 no-gutter">
                        <div class="col-sm-6 col-md-6">
                            <label>จากวันที่ใบงาน</label>
                            <div class="input-group date">
                                <input type="text" id="fdate" class="form-control" placeholder="วว/ดด/ปปปป" value='<?php echo MyDate::dateToText($fdate); ?>'/>
                                <span class="input-group-addon btn btn-primary"><span class="fa fa-calendar"></span></span>
                            </div>
                        </div>
                        <div class="col-sm-6 col-md-6">
                            <label>ถึงวันที่</label>
                            <div class="input-group date">
                                <input type="text" id="edate" class="form-control" placeholder="วว/ดด/ปปปป" value='<?php echo MyDate::dateToText($edate); ?>'/>
                                <span class="input-group-addon btn btn-primary"><span class="fa fa-calendar"></span></span>
                            </div>
                        </div>
                    </div>
                    <div class="col-sm-12 col-md-6 col-lg-6">
                        <label>คำค้นที่ต้องการ</label>
                        <div class="input-group">
                            <input class="form-control" type="text" id="txtsearch" placeholder="ค้นหา..." autofocus="true" value="<?php echo $txtsearch; ?>" style="font-size: 16px">
                            <span class="input-group-btn">
                                <button type="button" class="btn btn-primary" onclick="loadGridView()"><i class="fa fa-search"></i> ค้นหา</button>
                            </span>
                        </div>
                    </div>
                </div>

                <div id="div_grid">
                    <?php $this->renderPartial('_gridview', array('grids' => $grids)); ?>
                </div>
            </div>

        </div>
    </div>
</div>

<!-- Modal -->
<div class="modal fade colored-header" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true" data-backdrop="true">
</div>

<script type='text/javascript'>
    $(function () {
        $('.input-group.date').datepicker({
            todayBtn: 'linked',
            language: "th-th",
            keyboardNavigation: true,
            autoclose: true,
            todayHighlight: true,
            format: "dd/mm/yyyy"
        });
        $(".input-group.date input").inputmask("dd/mm/yyyy", {"placeholder": "วว/ดด/ปปปป"});

        $('#txtsearch').keydown(function (e) {
            if ((e.keyCode == 13)) {
                loadGridView();
                return true;
            }
        });
    });

    function loadGridView(url) {
        url = typeof url !== 'undefined' ? url : "<?php echo Yii::app()->createUrl('functionsheet/ajaxList') ?>";
        var p = {};
        p['txtsearch'] = $('#txtsearch').val();
        p['fdate'] = $('#fdate').val();
        p['edate'] = $('#edate').val();

        $('#div_grid').load(url, p);
        $('#txtsearch').focus();
        return true;
    }

    function del(id) {
        bootbox.confirm(artalert('warning', 'คุณต้องการลบข้อมูลรายการนี้ ใช่หรือไม่!!'), function (result) {
            if (result) {
                var p = {};
                p['id'] = id;
                $.ajax({
                    data: p,
                    url: "<?php echo Yii::app()->createUrl('functionsheet/ajaxDelete') ?>",
                    type: 'POST',
                    dataType: 'json',
                    success: function () {
                        loadGridView();
                    },
                    error: function () {
                        bootbox.alert(artalert('danger', 'ไม่สามารถทำรายการได้ กรุณาลองใหม่อีกครั้ง !!'));
                    }
                });
            }
        });
        return true;
    }
</script>