<?php
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/datepicker3.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/bootstrap-datepicker.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/bootstrap-datepicker-thai.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap-datepicker/locales/bootstrap-datepicker.th.js', CClientScript::POS_END);

$this->pageTitle = Yii::app()->name . ' ตารางการใช้ห้องประจำวัน';
$this->breadcrumbs = array(
    'ตารางการใช้ห้องประจำวัน'
);
?>

<div class="row">
    <div class="col-sm-12 col-md-12">
        <div class="block-flat" style="margin-bottom:20px;">
            <div class='content no-padding'>
                <div class='form-horizontal'>
                    <div class='form-group'>
                        <label class="col-md-2 control-label">ประจำวันที่</label>
                        <div class="col-md-4">
                            <div class="input-group date">
                                <input class="form-control" type="text" id="start_date" name="start_date" placeholder="วว/ดด/ปี พ.ศ." value='<?php echo $start_date; ?>' style='font-size:16px'/>
                                <span class="input-group-addon btn btn-primary"><span class="glyphicon glyphicon-th"></span></span>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<div class='row'>
    <div class='col-md-12'>
        <div id="div_grid">
            <?php $this->renderPartial('//query/_gridview_roomtable', array('tbl' => $tbl)); ?>
        </div>
    </div>
</div>

<!-- Modal รายละเอียดการจอง-->
<div class="modal fade colored-header" id="myModalDetailMore" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true" data-backdrop="true">
</div>

<script type='text/javascript'>
    $(function () {
        $('.input-group.date').datepicker({
            todayBtn: 'linked',
            language: "th-th",
            keyboardNavigation: true,
            autoclose: true,
            todayHighlight: true,
            orientation: "top auto",
            format: "dd/mm/yyyy"
        }).on('changeDate', function (e) {
            load_div_grid();
        });

    });

    function load_div_grid(url) {
        url = typeof url !== 'undefined' ? url : "<?php echo Yii::app()->createUrl('roomtable/ajaxList') ?>";
        var p = {};
        p['start_date'] = $('#start_date').val();

        $('#div_grid').load(url, p);
        $('#div_grid').focus();
        return true;
    }


    function showEventMore(reserv_id) {
        var p = {};
        p['reserv_id'] = reserv_id;
        $('#myModalDetailMore').load("<?php echo Yii::app()->createUrl('calendar/ajaxDetailMore') ?>", p, function () {
            $('#myModalDetailMore').modal('show');
        });
        return true;
    }
</script>