<?php
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/chosen/chosen.css');
Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/chosen/chosen-bootstrap.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/chosen/chosen.jquery.min.js');

Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/jquery.numeric.js', CClientScript::POS_END);

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/jasny-bootstrap/jasny-bootstrap.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/jasny-bootstrap/jasny-bootstrap.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/jasny-bootstrap/jasny-bootstrap-inputmask.js', CClientScript::POS_END);

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/facebox/facebox.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/facebox/facebox.js', CClientScript::POS_END);

$this->pageTitle = Yii::app()->name . ' บันทึกจองใช้ห้อง';

$newORedit = ($model->id == '') ? 'เพิ่ม' : 'แก้ไข';
$this->breadcrumbs = array(
    'รายการจองใช้ห้อง' => array('/reserv'),
    'เลือกช่วงวันที่ และห้องประชุม' => array('reserv/create'),
    "บันทึกจองใช้ห้อง ($newORedit)"
);

$classLabel = 'col-sm-2 control-label';
$classDiv = 'col-sm-4';
$this->renderPartial('//layouts/hasFlash');
?>

<style>
    .div-image-center{
        background-color: #FFF;
        width: 200px;
        height: 150px;
        line-height: 150px;
        text-align: center;
    }
</style>
<div class="row" id='headRow'>
    <div class="col-sm-12 col-md-12">
        <?php
        $form = $this->beginWidget('CActiveForm', array(
            'id' => 'myform',
            'enableClientValidation' => false,
            'enableAjaxValidation' => false,
            'htmlOptions' => array(
                'class' => 'form-horizontal',
                'enctype' => 'multipart/form-data',
            ),
            'action' => Yii::app()->createUrl('reserv/update'), //<- your form action here
        ));
        ?>

        <div class="block-flat" style='margin-bottom:20px'>
            <header>
                <span class="widget-icon"> <i class="fa fa-edit"></i></span>
                <h2>รายละเอียดการจอง</h2>
                <?php if ($model->status == '9') : ?>
                    <div class="widget-toolbar">
                        <span class="label label-danger">คุณต้องบันทึกรายการภายใน <strong><?php echo MyDate::dateToText($model->time_expire,true);?></strong></span>
                    </div>
                <?php endif; ?>
                <div class="clearfix"></div>
            </header>
            <div class='content'>
                <div class="alert alert-danger fade in no-margin" style="display:none" id="alert_frm"></div>
                <input type="hidden" id="id" name='id' value="<?php echo $model->id; ?>"/>
                <?php
                echo $form->hiddenField($model, 'room_id');
                echo $form->hiddenField($model, 'start_date');
                echo $form->hiddenField($model, 'end_date');
                $roomRow = Room::model()->findByPk($model->room_id);
                $roomDetail = "<strong>จำนวนที่นั่ง </strong>$roomRow->sit_amount <b>ที่นั่ง</b><br/><strong>อาคาร/สถานที่ </strong>$roomRow->place";

                $imagePath = Room::model()->getImagePath($model->room_id, "picture1");
                ?>
                <div class="row" style="margin-bottom:0px">
                    <div class="col-sm-3">
                        <div class="thumbnail">
                            <img src="<?php echo $imagePath; ?>" class="img-responsive">
                        </div>
                    </div>
                    <div class="col-sm-9">
                        <div>
                            <div class="pull-left">
                                <h3 class="name" style="margin-top: 5px"><?php echo $roomRow->name; ?></h3>
                            </div>
                            <div class='pull-right' style="padding-top:5px;text-align: right">
                                <?php
                                if ($model->status == '2' && $model->cancel_doc == '1') {
                                    echo '<span class="label label-primary">อนุมัติ(ขอยกเลิก)</span>';
                                } else {
                                    echo Reserv::model()->getLabelStatus($model->id);
                                }

                                if ($model->status == '1') {
                                    echo "<p><i class='label label-default'>" . MyDate::dateToText($model->read_date, true) . "</i></p>";
                                } else if ($model->status > 1) {
                                    echo "<p><i class='label label-default'>" . MyDate::dateToText($model->approve_date, true) . "</i></p>";
                                }
                                ?>
                            </div>
                            <div class='clearfix'></div>
                        </div>
                        <p style="font-size:14px"><?php echo $roomDetail; ?></p>
                        <div>
                            <strong>วันที่ใช้ห้อง </strong> <?php echo MyDate::dateThaiShort($model->start_date) . " เวลา " . date("H:i", strtotime($model->start_date)); ?>
                            <strong>&nbsp;&nbsp;ถึงวันที่&nbsp;&nbsp;</strong> <?php echo MyDate::dateThaiShort($model->end_date) . " เวลา " . date("H:i", strtotime($model->end_date)); ?>
                        </div>
                    </div>
                </div>

                <?php if ($model->status != '0' && $model->status != '9'): ?>
                    <div class="alert alert-warning"><strong>รายการจองนี้จะไม่สามารถแก้ไขได้</strong> เนื่องจากผู้อนุมัติได้ทำการ <u><strong><?php echo Reserv::model()->getStatusText($model->status); ?></strong></u> แล้ว</div>
                <?php endif; ?>

                <?php if ($model->status > 1 && $model->status != '9' && strlen($model->approve_comment) > 0): ?>
                    <div class="alert alert-info"><strong>หมายเหตุการอนุมัติ: </strong><?php echo $model->approve_comment; ?></div>
                <?php endif; ?>
            </div>  <!-- end content -->

        </div>

        <div class="tab-container">
            <ul class="nav nav-tabs">
                <li class="active"><a href="#tab1" data-toggle="tab" id='toggle-tab1'>รายละเอียดจอง</a></li>
                <li><a href="#tab2" data-toggle="tab" id='toggle-tab2'>ไฟล์ประกอบการประชุม</a></li>
            </ul>
            <div class="tab-content" style='margin-bottom:10px;'>
                <div class="tab-pane active cont" id="tab1">
                    <div class="form-group">
                        <label class="<?php echo $classLabel; ?>">เลขที่ใบจอง<span class="required">*</span></label>
                        <div class="<?php echo $classDiv; ?>">
                            <div class="input-group">
                                <?php echo $form->textField($model, 'docno', array('class' => 'form-control', 'autofocus' => 'true', 'required' => 'true')); ?>
                                <span class="input-group-btn">
                                    <button type="button" class="btn btn-default" onclick="docrun()"><i class="fa fa-flash"></i></button>
                                </span>
                            </div>
                        </div>

                        <label class="<?php echo $classLabel; ?>">วันที่เวลา</label>
                        <div class="<?php echo $classDiv; ?>">
                            <?php
                            $model->docdate = MyDate::dateThaiShort($model->docdate);
                            ?>
                            <input type="text" value='<?php echo $model->docdate . " เวลา " . $model->doctime; ?>' class='form-control' readonly="" tabindex="-1"/>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">วาระการประชุม<span class="required">*</span></label>
                        <div class="col-sm-10">
                            <?php echo $form->textField($model, 'title', array('class' => 'form-control', 'required' => 'true')); ?>
                        </div>
                    </div>


                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">ประธานการประชุม<span class="required">*</span></label>
                        <div class="col-sm-10">
                            <?php echo $form->textField($model, 'manager', array('class' => 'form-control', 'placeholder' => 'ที่อยู่ หรือชื่อสถานที่', 'required' => 'true')); ?>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">จำนวนผู้เข้าประชุม</label>
                        <div class="<?php echo $classDiv; ?>">
                            <div class="input-group">
                                <?php echo $form->textField($model, 'human_amount', array('class' => 'form-control numeric')); ?>
                                <span class="input-group-addon">คน</span>
                            </div>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">รายชื่อผู้เข้าประชุม</label>
                        <div class="col-sm-10">
                            <?php echo $form->textArea($model, 'human_name', array('rows' => 2, 'class' => 'form-control')); ?>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">ใช้สำหรับแผนก</label>
                        <div class="<?php echo $classDiv; ?>">
                            <select name="Reserv[depart_id]" data-placeholder="ป้อนหรือคลิกเลือกรายการ" class="chzn-select-deselect form-control" required="" title='คุณต้องเลือกจังหวัด'>
                                <option value=""></option>
                                <?php
                                $departs = Depart::model()->findAll(array('order' => 'name asc'));
                                foreach ($departs as $r) {
                                    $selected = ($model->depart_id == $r->id) ? 'selected' : '';
                                    echo "<option value='$r->id' $selected>$r->name</option>";
                                }
                                ?>
                            </select>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">ผู้ขอใช้</label>
                        <div class="<?php echo $classDiv; ?>">
                            <?php echo $form->textField($model, 'person_name', array('class' => 'form-control')); ?>
                        </div>

                        <label class="<?php echo $classLabel; ?>">โทรศัพท์ติดต่อ</label>
                        <div class="<?php echo $classDiv; ?>">
                            <?php echo $form->textField($model, 'tel', array('class' => 'form-control')); ?>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">อัตราค่าเช่า</label>
                        <div class="<?php echo $classDiv; ?>">
                            <div class="input-group">
                                <?php
                                $model->room_rate = number_format($model->room_rate, 2);
                                echo $form->textField($model, 'room_rate', array('class' => 'form-control numeric', 'readonly' => 'true'));
                                ?>
                                <span class="input-group-addon">บาท:นาที</span>
                            </div>
                        </div>

                        <label class="<?php echo $classLabel; ?>">ค่าเช่าสทุธิ</label>
                        <div class="<?php echo $classDiv; ?>">
                            <div class="input-group">
                                <?php
                                $model->room_money = number_format($model->room_money, 2);
                                echo $form->textField($model, 'room_money', array('class' => 'form-control numeric', 'readonly' => 'true'));
                                ?>
                                <span class="input-group-addon">บาท</span>
                            </div>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">อุปกรณ์ที่ต้องการ</label>
                        <div class="col-sm-10">
                            <select id="select_equipment" data-placeholder="ป้อนหรือคลิกเลือกรายการ" class="chzn-select form-control" multiple title='เลือกอุปกรณ์ที่ต้องการ'>
                                <option value=""></option>
                                <?php
                                $equips = Equip::model()->findAll(array('order' => 'name asc'));
                                $arr_equips = explode(',', $model->equipment);
                                foreach ($equips as $r) {
                                    $selected = (in_array($r->name, $arr_equips)) ? 'selected' : '';
                                    echo "<option value='$r->name' $selected>$r->name</option>";
                                }
                                ?>
                            </select>
                            <?php echo $form->hiddenField($model, 'equipment'); ?>
                        </div>
                    </div>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">เพิ่มเติม</label>
                        <div class="col-sm-10">
                            <?php echo $form->textArea($model, 'comment', array('rows' => 2, 'class' => 'form-control')); ?>
                        </div>
                    </div>

                    <?php if ($model->status == '9' || $model->status == '0'): ?>
                        <div class='form-group'>
                            <label class="<?php echo $classLabel; ?>">ส่งเรื่องจอง</label>
                            <div class="col-sm-10">
                                <?php
                                if ($model->date_edit == '') {
                                    $model->status = '0';
                                }

                                $company = Company::model()->find();
                                $txtApprove = 'ส่งเรื่องทันทีเมื่อบันทึก';
                                if ($company->approve_auto == '1') {
                                    $txtApprove = 'อนุมัติอัตโนมัติทันทีเมื่อบันทึก';
                                }
                                ?>
                                <label class="radio-inline" style='padding-left:0px;'> <input type="radio" <?php echo ($model->status == '0') ? 'checked' : ''; ?> name="Reserv[status]" class="icheck" value='0'> <?php echo $txtApprove; ?></label> 
                                <label class="radio-inline"> <input type="radio" <?php echo ($model->status == '9') ? 'checked' : ''; ?> name="Reserv[status]" class="icheck" value='9'> ยังไม่ส่งเรื่อง (ผู้อนุมัติจะไม่เห็นรายการแต่ห้องจะถูกจองไว้ก่อน)</label>
                            </div>
                        </div>
                    <?php endif; ?>

                    <div class='form-group'>
                        <label class="<?php echo $classLabel; ?>">เปิดเผยไฟล์</label>
                        <div class="col-sm-10">
                            <label class="radio-inline" style='padding-left:0px;'> <input type="radio" <?php echo ($model->public_file == '0') ? 'checked' : ''; ?> name="Reserv[public_file]" class="icheck" value='0'> ใช่</label> 
                            <label class="radio-inline"> <input type="radio" <?php echo ($model->public_file == '1') ? 'checked' : ''; ?> name="Reserv[public_file]" class="icheck" value='1'> ต้อง login เข้าระบบ</label>
                        </div>
                    </div>

                    <?php if ($model->status == '2' && $model->cancel_doc == '1'): ?>
                        <div class='form-group'>
                            <label class="<?php echo $classLabel; ?>">เหตุผลขอยกเลิก</label>
                            <div class="col-sm-10">
                                <?php echo $form->textArea($model, 'cancel_comment', array('rows' => 2, 'class' => 'form-control', 'readonly' => 'true')); ?>
                            </div>
                        </div>
                    <?php endif; ?>
                </div>
                <div class='tab-pane cont' id='tab2'>
                    <?php $baseUrl = Yii::app()->request->baseUrl; ?>
                    <fieldset>
                        <legend><i class="fa fa-picture-o"></i> ไฟล์ประกอบการประชุม</legend>
                        <div class="alert alert-info">ห้ามอัพโหลดไฟล์นามสกุล .php, .js, .exe และ .bat <b>ขนาดไฟล์ไม่เกิน:</b> <?php echo MyFn::getUploadMaxSize(); ?> MB</div>
                        <div class='alert alert-warning' style='text-align: center'><h3>สำหรับการทดสอบโปรแกรม ไม่อนุญาติให้แนบไฟล์</h3></div>
                    </fieldset>
                </div>
            </div>
        </div>

        <div class='block-flat'>
            <div class="content">
                <?php if ($model->status == '0' || $model->status == '9'): ?>
                    <div style='text-align: center'>
                        <div class="row no-margin">
                            <button type="button" class="btn btn-primary btn-lg" onclick="save();">
                                <i class="fa fa-save"></i>
                                บันทึกข้อมูล
                            </button>
                        </div>
                    </div>
                <?php endif; ?>
            </div>
        </div>
        <?php $this->endWidget(); ?>
    </div>
</div>

<script type="text/javascript">

</script>

<script type='text/javascript'>
    $(document).ready(function () {
        $(".numeric").numeric({negative: false});

        $(".chzn-select-deselect, .chzn-select").chosen({
            allow_single_deselect: true,
            no_results_text: 'ไม่พบรายชื่อ!',
            search_contains: true
        });

        $('#myform').validate({ignore: ":hidden:not(select)",
            invalidHandler: function (event, validator) {
                loadingStaticRemove();
            }
        });

        //$("#select_equipment").trigger("liszt:updated");
    });

    function save() {
        $('#Reserv_equipment').val($('#select_equipment').chosen().val());

        var p = {};
        p['save'] = true;
        p['id'] = $('#id').val();
        p['code'] = $('#Reserv_docno').val();

        $.ajax({
            data: p,
            url: "<?php echo Yii::app()->createUrl('reserv/ajaxValidate') ?>",
            type: 'POST',
            dataType: 'json',
            success: function (data) {
                scrollToTop();
                if (data.msg == '0') {
                    loadingStatic();
                    $('#myform').submit();
                } else {
                    bootbox.alert(artalert('danger', data.msgText));
                }
            },
            error: function () {
                bootbox.alert(artalert('danger', 'ไม่สามารถบันทึกข้อมูลได้ กรุณาลองใหม่อีกครั้ง !!'));
            }
        });
        return true;
    }

    function del(id) {
        bootbox.confirm(artalert('warning', 'คุณต้องการลบข้อมูลรายการนี้ ใช่หรือไม่!!'), function (result) {
            if (result) {
                var p = {};
                p['id'] = id;
                $.ajax({
                    data: p,
                    url: "<?php echo Yii::app()->createUrl('reserv/ajaxDelete') ?>",
                    type: 'POST',
                    dataType: 'json',
                    success: function () {
                        window.location.href = "<?php echo Yii::app()->createUrl('reserv/create'); ?>"
                    },
                    error: function () {
                        bootbox.alert(artalert('danger', 'ไม่สามารถทำรายการได้ กรุณาลองใหม่อีกครั้ง !!'));
                    }
                });
            }
        });

        return true;
    }

    //รันเลขที่เอกสาร
    function docrun() {
        var p = {};
        p['docprefix_id'] = '1';
        $.ajax({
            data: p,
            url: "<?php echo Yii::app()->createUrl('docrun/ajaxGetDocNo') ?>",
            type: 'POST',
            dataType: 'json',
            success: function (data) {
                $('#Reserv_docno').val(data.docno);
            },
            error: function () {
                bootbox.alert(artalert('danger', 'ไม่สามารถทำรายการได้ กรุณาลองใหม่อีกครั้ง !!'));
            }
        });

        return true;
    }

    //ลบไฟล์
    function deleteFile(id, fileNumber) {
        bootbox.confirm(artalert('warning', 'คุณต้องการลบไฟล์รายการนี้ ใช่หรือไม่!!'), function (result) {
            if (result) {
                var p = {};
                p['id'] = id;
                p['fileNumber'] = fileNumber;
                $.ajax({
                    data: p,
                    url: "<?php echo Yii::app()->createUrl('reserv/ajaxDeleteFile') ?>",
                    type: 'POST',
                    dataType: 'json',
                    success: function () {
                        $('#spanfile' + fileNumber).html('');
                    },
                    error: function () {
                        bootbox.alert(artalert('danger', 'ไม่สามารถทำรายการได้ กรุณาลองใหม่อีกครั้ง !!'));
                    }
                });
            }
        });
        return true;
    }
</script>