<?php
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/jquery.numeric.js', CClientScript::POS_END);

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/jasny-bootstrap/jasny-bootstrap.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/jasny-bootstrap/jasny-bootstrap.js', CClientScript::POS_END);

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/facebox/facebox.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/facebox/facebox.js', CClientScript::POS_END);

Yii::app()->clientScript->registerCssFile(Yii::app()->baseUrl . '/js/fancyapp/source/jquery.fancybox.css');
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/fancyapp/source/jquery.fancybox.pack.js', CClientScript::POS_END);
Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/fancyapp/lib/jquery.mousewheel-3.0.6.pack.js', CClientScript::POS_END);

Yii::app()->clientScript->registerScriptFile(Yii::app()->baseUrl . '/js/bootstrap-typeahead.min.js', CClientScript::POS_END);

$this->pageTitle = Yii::app()->name . ' รายละเอียดห้องประชุม';

$newORedit = ($model->id == '') ? 'เพิ่ม' : 'แก้ไข';
$this->breadcrumbs = array(
    'ข้อมูลห้องประชุม' => array('/room'),
    "รายละเอียดห้องประชุม ($newORedit)"
);

$classLabel = 'col-sm-2 control-label';
$classDiv = 'col-sm-4';
$this->renderPartial('//layouts/hasFlash');
?>

<style>
    .div-image-center{
        background-color: #FFF;
        width: 200px;
        height: 150px;
        line-height: 150px;
        text-align: center;
    }
    ul.typeahead li a{
        font-size: 14px;
    }
</style>

<div class="row" id='headRow'>
    <div class="col-sm-12 col-md-12">

        <div class="block-flat">
            <header>
                <span class="widget-icon"> <i class="fa fa-edit"></i></span>
                <h2>รายละเอียดห้อง</h2>	
                <div class="widget-toolbar">
                    <?php echo CHtml::link('<i class="fa fa-plus"></i> เพิ่มข้อมูล', array('room/create'), array('class' => 'btn btn-xs btn-success')); ?>
                    <?php
                    echo '<a href="#" onclick="return del(\'' . $model->id . '\')" class="btn btn-xs btn-danger"><i class="fa fa-trash-o"></i> ลบข้อมูล</a>';
                    ?>
                </div>
                <div class="clearfix"></div>
            </header>

            <div class='content'>
                <?php
                $form = $this->beginWidget('CActiveForm', array(
                    'id' => 'myform',
                    'enableClientValidation' => false,
                    'enableAjaxValidation' => false,
                    'htmlOptions' => array(
                        'class' => 'form-horizontal',
                        'enctype' => 'multipart/form-data',
                    ),
                    'action' => Yii::app()->createUrl('room/update'), //<- your form action here
                ));
                ?>

                <div class="alert alert-danger fade in no-margin" style="display:none" id="alert_frm"></div>
                <input type="hidden" id="id" name='id' value="<?php echo $model->id; ?>"/>

                <div class="form-group">
                    <label class="col-md-2 control-label">ชื่อห้อง<span class="required">*</span></label>
                    <div class="col-md-10">
                        <?php $model->name = CHtml::decode($model->name); ?>
                        <?php echo $form->textField($model, 'name', array('class' => 'form-control', 'autofocus' => 'true', 'required' => 'true')); ?>
                    </div>
                </div>

                <div class='form-group'>
                    <label class="col-md-2 control-label">จำนวนที่นั่ง</label>
                    <div class="col-md-4">
                        <div class="input-group">
                            <?php echo $form->textField($model, 'sit_amount', array('class' => 'form-control numeric')); ?>
                            <span class="input-group-addon">ที่นั่ง</span>
                        </div>
                    </div>
                </div>

                <div class='form-group'>
                    <label class="col-md-2 control-label">สถานะ</label>
                    <div class="col-md-4">
                        <select id="Room_status" name="Room[status]" class="form-control">
                            <option value="0" <?php if ($model->status == '0') echo 'selected'; ?>>ปกติ</option>
                            <option value="1" <?php if ($model->status == '1') echo 'selected'; ?>>ซ่อมแซม</option>
                            <option value="2" <?php if ($model->status == '2') echo 'selected'; ?>>งดให้บริการชั่วคราว</option>
                            <option value="3" <?php if ($model->status == '3') echo 'selected'; ?>>ยกเลิกใช้</option>
                        </select>
                    </div>
                </div>

                <div class="form-group">
                    <label class="col-md-2 control-label">อาคาร/สถานที่</label>
                    <div class="col-md-10">
                        <?php echo $form->textField($model, 'place', array('class' => 'form-control', 'autocomplete' => 'off')); ?>
                    </div>
                </div>

                <div class='form-group'>
                    <label class="col-md-2 control-label">ค่าเช่า:นาที</label>
                    <div class="col-md-3">
                        <div class="input-group">
                            <?php
                            $model->rate = number_format($model->rate, 2);
                            echo $form->textField($model, 'rate', array('class' => 'form-control numeric'));
                            ?>
                            <span class="input-group-btn">
                                <button type="button" class="btn btn-default" data-toggle="modal" data-target="#myModalCalculator"><i class="fa fa-usd"></i></button>
                            </span>
                        </div>
                    </div>
                </div>

                <div class="form-group">
                    <label class="col-md-2 control-label">รายละเอียดห้อง</label>
                    <div class="col-md-10">
                        <?php echo $form->textArea($model, 'detail', array('rows' => 2, 'class' => 'form-control')); ?>
                    </div>
                </div>

                <div class='form-group'>
                    <label class="col-md-2 control-label">ผู้ดูแลห้อง</label>
                    <div class="col-md-10">
                        <?php echo $form->textField($model, 'person_name', array('class' => 'form-control')); ?>
                    </div>
                </div>

                <div class='form-group'>
                    <label class="col-md-2 control-label">เบอร์ติดต่อ</label>
                    <div class="col-md-10">
                        <?php echo $form->textField($model, 'phone', array('class' => 'form-control')); ?>
                    </div>
                </div>

                <br/>
                <?php $baseUrl = Yii::app()->request->baseUrl; ?>
                <fieldset>
                    <legend><i class="fa fa-picture-o"></i> ภาพประกอบ</legend>
                    <div class="alert alert-info">ขนาดภาพที่เหมาะสมคือ 640 x 480 pixel (ภาพแรกจะเป็นภาพหลักประจำห้อง)</div>
                    <?php
                    for ($i = 1; $i < 5; $i++):
                        $imagePath = Room::model()->getImagePath($model->id, "picture$i");
                        ?>
                        <div class="fileinput fileinput-new" data-provides="fileinput" style="margin-left:5px;">
                            <div class="fileinput-new thumbnail div-image-center">
                                <a href='<?php echo $imagePath; ?>' class='fancybox' rel="gallery1" title='ภาพประกอบห้องประชุม <?php echo $i; ?>'>
                                    <img src="<?php echo $imagePath; ?>" alt="ภาพประกอบห้อง <?php echo $i; ?>" class="img-responsive">
                                </a>
                            </div>
                            <div class="fileinput-preview fileinput-exists thumbnail div-image-center"></div>
                            <div>
                                <span class="btn btn-default btn-file"><span class="fileinput-new">เลือกรูปห้อง <?php echo $i; ?></span><span class="fileinput-exists">เปลี่ยน</span><input type="file" name="<?php echo "picture$i"; ?>"></span>
                                <a href="#" class="btn btn-default fileinput-exists" data-dismiss="fileinput">ยกเลิก</a>
                            </div>
                        </div>
                    <?php endfor; ?>
                </fieldset>

                <div class="form-actions form-actions-gt">
                    <div class="row no-margin">
                        <button type="button" class="btn btn-primary btn-lg" onclick="save();">
                            <i class="fa fa-save"></i>
                            บันทึกข้อมูล
                        </button>
                    </div>
                </div>

                <?php $this->endWidget(); ?>
            </div>

        </div>

    </div>
</div>

<!-- Modal -->

<!-- Modal -->
<div class="modal fade colored-header" id="myModalCalculator" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true" data-backdrop="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                <h4 class="modal-title" id="myModalLabel">แปลงเป็นค่าเช่า ต่อนาที</h4>
            </div>

            <div class='form-horizontal'>
                <div class="modal-body">
                    <div class="form-group">
                        <label class="col-md-3 control-label">แปลงจาก</label>
                        <div class="col-md-6">
                            <select id="ddlCal" class='form-control'>
                                <option value="0">ชั่วโมง => นาที</option>
                                <option value="1">วันเป็น => นาที</option>
                            </select>
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="col-md-3 control-label">ค่าเช่า(บาท)</label>
                        <div class="col-md-4">
                            <div class="input-group">
                                <input type='text' id='num_convert' value='' class='form-control numberic' autofocus=""/>
                                <span class="input-group-addon">บาท : x</span>
                            </div>
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="col-md-3 control-label">แปลงได้นาทีละ</label>
                        <div class="col-md-4">
                            <div class="input-group">
                                <input type='text' id='num_rate' value='' class='form-control numberic' readonly=""/>
                                <span class="input-group-addon">บาท</span>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" data-dismiss="modal" name="a"> ปิด </button>
                    <button type="button" class="btn btn-primary" name="b" onclick="calculatorOk()"> ตกลง</button>
                </div>
            </div>

        </div>
    </div>
</div>

<script type='text/javascript'>
    $(document).ready(function () {
        $(".numeric").numeric({negative: false});

        $('#myform').validate({ignore: ":hidden:not(select)",
            invalidHandler: function (event, validator) {
                loadingStaticRemove();
            }
        });

        $('#num_convert').keyup(function () {
            calculator();
        });
        $('#ddlCal').change(function () {
            calculator();
        });

        $('.modal').on('shown.bs.modal', function () {
            $(this).find("[autofocus]:first").focus();
        });

        $(".fancybox").fancybox();

        $('#Room_place').typeahead({
            ajax: {
                url: "<?php echo Yii::app()->createUrl('room/typeAhead') ?>",
                timeout: 200,
                displayField: "place",
                triggerLength: 2,
                method: "get",
                loadingClass: "loading-circle",
                preDispatch: function (query) {
                   loadingStaticRemove();
                }
            }
        });
    });

    function save() {
        var p = {};
        p['save'] = true;
        p['id'] = $('#id').val();
        p['name'] = $('#Room_name').val();

        $.ajax({
            data: p,
            url: "<?php echo Yii::app()->createUrl('room/ajaxValidate') ?>",
            type: 'POST',
            dataType: 'json',
            success: function (data) {
                scrollToTop();
                if (data.msg == '0') {
                    loadingStatic();
                    $('#myform').submit();
                } else {
                    bootbox.alert(artalert('danger', data.msgText));
                }
            },
            error: function () {
                bootbox.alert(artalert('danger', 'ไม่สามารถบันทึกข้อมูลได้ กรุณาลองใหม่อีกครั้ง !!'));
            }
        });
        return true;
    }

    function del(id) {
        bootbox.confirm(artalert('warning', 'คุณต้องการลบข้อมูลรายการนี้ ใช่หรือไม่!!'), function (result) {
            if (result) {
                var p = {};
                p['id'] = id;
                $.ajax({
                    data: p,
                    url: "<?php echo Yii::app()->createUrl('room/ajaxDelete') ?>",
                    type: 'POST',
                    dataType: 'json',
                    success: function () {
                        window.location.href = "<?php echo Yii::app()->createUrl('room/create'); ?>"
                    },
                    error: function () {
                        bootbox.alert(artalert('danger', 'ไม่สามารถทำรายการได้ กรุณาลองใหม่อีกครั้ง !!'));
                    }
                });
            }
        });

        return true;
    }

    function calculator() {
        var numresult;
        if ($('#ddlCal').val() == '0') {
            //ชั่วโมง==>นาที
            numresult = $('#num_convert').val() / 60;
        } else {
            //วัน==>นาที
            numresult = $('#num_convert').val() / (24 * 60);
        }

        $('#num_rate').val(numresult.toFixed(2));
    }
    function calculatorOk() {
        $('#Room_rate').val($('#num_rate').val());
        $('#myModalCalculator').modal('hide');
    }
</script>